SystemOrganization addCategory: #'Metacello-MC-Directives'!
SystemOrganization addCategory: #'Metacello-MC-Gofer'!
SystemOrganization addCategory: #'Metacello-MC-Loaders'!
SystemOrganization addCategory: #'Metacello-MC-Model'!
SystemOrganization addCategory: #'Metacello-MC-Specs'!

!MCDictionaryRepository methodsFor: '*metacello-mc' stamp: 'DaleHenrichs 3/5/2010 14:45'!
asRepositorySpecFor: aMetacelloMCProject

	^(aMetacelloMCProject repositorySpec)
		description:  'dictionary://Metacello_Dictionary';
	 	type: 'dictionary';
		yourself! !

!MCDictionaryRepository methodsFor: '*metacello-mc' stamp: 'dkh 12/22/2009 12:06'!
versionInfoFromVersionNamed: aString

	| versions |
	versions := self dictionary values select: [:version | version info name beginsWith: aString ].
	versions isEmpty ifTrue: [ ^ nil ].
	versions := versions asSortedCollection: [ :a :b |
		([ (a info name copyAfterLast: $.) asNumber ] on: Error do: [:ex | ex return: 0 ]) <= 
			([ (b info name copyAfterLast: $.) asNumber ] on: Error do: [:ex | ex return: 0 ]) ].
	^ versions last info! !

!MCFileBasedRepository methodsFor: '*metacello-mc' stamp: 'dkh 10/20/2009 11:25'!
versionInfoFromVersionNamed: aString

	| versions |
	versions := self allVersionNames
		select: [ :each | each beginsWith: aString ].
	versions isEmpty ifTrue: [ ^ nil ].
	versions := versions asSortedCollection: [ :a :b |
		([ (a copyAfterLast: $.) asNumber ] on: Error do: [:ex | ex return: 0 ]) <= 
			([ (b copyAfterLast: $.) asNumber ] on: Error do: [:ex | ex return: 0 ]) ].
	^ self versionInfoFromFileNamed: versions last , '.mcz'! !

!MetacelloMemberSpec methodsFor: '*metacello-mc' stamp: 'dkh 6/7/2009 18:14'!
addToMetacelloPackages: aMetacelloPackagesSpec

	aMetacelloPackagesSpec addMember: self! !

!MetacelloMemberSpec methodsFor: '*metacello-mc' stamp: 'dkh 6/7/2009 20:40'!
addToMetacelloRepositories: aMetacelloRepositoriesSpec

	aMetacelloRepositoriesSpec addMember: self! !

!MetacelloMemberSpec methodsFor: '*metacello-mc' stamp: 'dkh 6/7/2009 18:31'!
mergeIntoMetacelloPackages: aMetacelloPackagesSpec

	aMetacelloPackagesSpec addMember: self! !

!MetacelloMemberSpec methodsFor: '*metacello-mc' stamp: 'dkh 6/7/2009 20:41'!
mergeIntoMetacelloRepositories: aMetacelloRepositoriesSpec

	aMetacelloRepositoriesSpec addMember: self! !

!MetacelloMemberSpec methodsFor: '*metacello-mc' stamp: 'dkh 6/7/2009 18:18'!
removeFromMetacelloPackages: aMetacelloPackagesSpec

	aMetacelloPackagesSpec addMember: self! !

!MetacelloMemberSpec methodsFor: '*metacello-mc' stamp: 'dkh 6/7/2009 20:41'!
removeFromMetacelloRepositories: aMetacelloRepositoriesSpec

	aMetacelloRepositoriesSpec addMember: self! !

!MCDirectoryRepository methodsFor: '*metacello-mc' stamp: 'DaleHenrichs 3/5/2010 14:44'!
asRepositorySpecFor: aMetacelloMCProject

	^(aMetacelloMCProject repositorySpec)
		description:  directory fullName;
	 	type: 'directory';
		yourself! !

!GoferResolvedReference methodsFor: '*metacello-mc' stamp: 'DaleHenrichs 1/12/2010 20:38'!
asMetacelloCachingResolvedReference

	^MetacelloCachingGoferResolvedReference name: self name repository: self repository! !

!GoferResolvedReference methodsFor: '*metacello-mc' stamp: 'DaleHenrichs 4/16/2010 14:10'!
compare: aLoadableReference using: aComparisonOperator
	"Compare versions using <aComparisonOperator>. package names #= then compare based upon:

		1. branch name, list versions without branch last
		2. version number
		3. author name

	 Otherwise compare based on versionNumber (package names assumed to be 'comparable').
		"
		
	self packageName = aLoadableReference packageName
		ifFalse: [ ^self versionNumber perform: aComparisonOperator with: aLoadableReference versionNumber ].
	self branch = aLoadableReference branch ifFalse: [ 
		^ (self branch isEmpty or: [ aLoadableReference branch isEmpty ])
			ifTrue: [ aLoadableReference branch size perform: aComparisonOperator with: self branch size ]
			ifFalse: [ self branch perform: aComparisonOperator with: aLoadableReference branch ] ].
	self versionNumber = aLoadableReference versionNumber
		ifFalse: [ ^ self versionNumber perform: aComparisonOperator with: aLoadableReference versionNumber ].
	^ self author perform: aComparisonOperator with: aLoadableReference author! !

GoferResolvedReference subclass: #MetacelloCachingGoferResolvedReference
	instanceVariableNames: 'cachedVersion'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metacello-MC-Gofer'!

!MetacelloCachingGoferResolvedReference methodsFor: 'accessing' stamp: 'DaleHenrichs 1/12/2010 20:40'!
version
	"Answer a Monticello version of the receiver."

	cachedVersion == nil ifTrue: [ cachedVersion := super version ].
	^cachedVersion! !

!MetacelloCachingGoferResolvedReference methodsFor: 'querying' stamp: 'DaleHenrichs 01/15/2010 17:15'!
workingCopy
	"Answer a working copy or throw an error if not present."

	| pName |
	cachedVersion == nil ifTrue: [ ^super workingCopy ].
	pName := cachedVersion package name.
	^MCWorkingCopy allManagers
		detect: [ :each | pName = each packageName ]
		ifNone: [ self error: 'Working copy for ' , self name , ' not found' ]! !

MetacelloMemberListSpec subclass: #MetacelloRepositoriesSpec
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metacello-MC-Specs'!

!MetacelloRepositoriesSpec methodsFor: 'actions' stamp: 'dkh 10/3/2009 16:52'!
add: aStringOrSpec

	aStringOrSpec addToMetacelloRepositories: self! !

!MetacelloRepositoriesSpec methodsFor: 'actions' stamp: 'dkh 6/7/2009 10:18'!
add: description type: type

	| spec |
	spec := 
		(self project repositorySpec)
			description: description;
			type: type;
			yourself.
	self addMember: 
		(self addMember 
			name: spec name;
			spec: spec;
			yourself)! !

!MetacelloRepositoriesSpec methodsFor: 'printing' stamp: 'dkh 1/2/2010 16:05'!
configMethodCascadeOn: aStream indent: indent

	| repositorySpecs |
	repositorySpecs := self map values sortBy: [:a :b | a description <= b description ].
	repositorySpecs size = 1
		ifTrue: [ repositorySpecs first configMethodCascadeOn: aStream lastCascade: true ]
		ifFalse: [
			1 to: repositorySpecs size do: [:index | | repositorySpec |
				aStream tab: indent + 1.
				(repositorySpecs at: index)
					configMethodCascadeOn: aStream 
					lastCascade: index >= repositorySpecs size ]]! !

!MetacelloRepositoriesSpec methodsFor: 'printing' stamp: 'dkh 1/2/2010 17:11'!
configMethodOn: aStream indent: indent

	aStream 
		tab: indent; 
		nextPutAll: 'spec';
		cr.
	self configMethodCascadeOn: aStream indent: indent! !

!MetacelloRepositoriesSpec methodsFor: 'actions' stamp: 'dkh 6/7/2009 10:18'!
merge: aRepositorySpec

	aRepositorySpec mergeIntoMetacelloRepositories: self! !

!MetacelloRepositoriesSpec methodsFor: 'actions' stamp: 'dkh 6/7/2009 20:50'!
merge: description type: type

	| spec |
	spec := 
		(self project repositorySpec)
			description: description;
			type: type;
			yourself.
	self addMember: 
		(self mergeMember 
			name: spec name;
			spec: spec;
			yourself)! !

!MetacelloRepositoriesSpec methodsFor: 'actions' stamp: 'dkh 6/7/2009 10:22'!
remove: aRepositorySpec

	aRepositorySpec removeFromMetacelloRepositories: self! !

!MetacelloRepositoriesSpec methodsFor: 'actions' stamp: 'dkh 10/6/2009 23:59'!
repository: aStringOrSpec

	aStringOrSpec addToMetacelloRepositories: self! !

!MetacelloRepositoriesSpec methodsFor: 'actions' stamp: 'dkh 10/22/2009 09:01'!
repository: description username: username password: password

	| spec |
	spec := 
		(self project repositorySpec)
			description: description;
			username: username;
			password: password;
			yourself.
	self addMember: 
		(self addMember 
			name: spec name;
			spec: spec;
			yourself)! !

!MetacelloGroupSpec methodsFor: '*metacello-mc' stamp: 'DaleHenrichs 3/5/2010 09:46'!
loadUsing: aLoader gofer: gofer
	"noop"! !

!MetacelloGroupSpec methodsFor: '*metacello-mc' stamp: 'DaleHenrichs 1/19/2010 12:14'!
resolveToLoadableSpec

	^nil! !

!MetacelloGroupSpec methodsFor: '*metacello-mc' stamp: 'DaleHenrichs 1/21/2010 15:54'!
resolveToPackagesIn: aVersionSpec into: packages visited: visited

	visited 
		visit: self 
		doing: [:aSpec | | map |
			map := aVersionSpec packages map.
			aSpec includes do: [:pkgName | 
				(aVersionSpec packageNamed: pkgName forMap: map ifAbsent: [])
					projectDo: [:ignored | ] 
					packageDo: [:pkg | packages at: pkg name put: pkg ] 
					groupDo: [:grp | grp resolveToPackagesIn: aVersionSpec into: packages visited: visited ]]]! !

!MetacelloGroupSpec methodsFor: '*metacello-mc' stamp: 'dkh 10/21/2009 15:23'!
resolveToPackagesIn: aVersionSpec visited: visited

	| packages |
	packages := Dictionary new.
	self resolveToPackagesIn: aVersionSpec into: packages visited: visited.
	^packages values asOrderedCollection! !

!MCRepository methodsFor: '*metacello-mc' stamp: 'DaleHenrichs 3/5/2010 14:37'!
asRepositorySpecFor: aMetacelloMCProject

	self subclassResponsibility! !

MetacelloVersionSpec subclass: #MetacelloMCVersionSpec
	instanceVariableNames: 'packages repositories'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metacello-MC-Specs'!

!MetacelloMCVersionSpec methodsFor: 'printing' stamp: 'dkh 10/9/2009 07:35'!
configMethodOn: aStream indent: indent

	| spec |
	super configMethodOn: aStream indent: indent.
	(((spec := self repositoriesSpec) ~~ nil)  and: [ spec list isEmpty not ])
		ifTrue: [
			spec map values size = 1
				ifTrue: [
					aStream 
						tab: indent; 
						nextPutAll: 'spec repository: '; 
						nextPutAll: spec map values first description printString, '.';
						cr ]
				ifFalse: [ self configMethodOn: aStream for: spec selector: 'repositories:' indent: indent ]].
	self configPackagesSpecMethodOn: aStream indent: indent! !

!MetacelloMCVersionSpec methodsFor: 'printing' stamp: 'dkh 10/6/2009 14:26'!
configPackagesSpecMethodOn: aStream indent: indent

	| projectSpecs packageSpecs groupSpecs |
	projectSpecs := OrderedCollection new.
	packageSpecs := OrderedCollection new.
	groupSpecs := OrderedCollection new.
	self packagesSpec list do: [:member |
		member spec 
			projectDo: [:proj | member spec name ~~ nil ifTrue: [ projectSpecs add: member ]]
			packageDo: [:package | member spec name ~~ nil ifTrue: [ packageSpecs add: member ]]
			groupDo: [:group | member spec name ~~ nil ifTrue: [ groupSpecs add: member ]]].
	projectSpecs isEmpty not
		ifTrue: [
			aStream tab: indent; nextPutAll: 'spec '.
			projectSpecs size > 1 ifTrue: [ aStream cr; tab: indent + 1 ].
			1 to: projectSpecs size  do: [:index | 
				(projectSpecs at: index) configMethodCascadeOn: aStream last: index == projectSpecs size indent: indent + 1.
				index ~= projectSpecs size ifTrue: [ aStream tab: indent + 1 ]]].
	packageSpecs isEmpty not
		ifTrue: [
			projectSpecs isEmpty not ifTrue: [ aStream cr ].
			aStream tab: indent; nextPutAll: 'spec '.
			packageSpecs size > 1 ifTrue: [ aStream cr; tab: indent + 1 ].
			1 to: packageSpecs size  do: [:index | 
				(packageSpecs at: index) configMethodCascadeOn: aStream last: index == packageSpecs size indent: indent + 1.
				index ~= packageSpecs size ifTrue: [ aStream tab: indent + 1 ]]].
	groupSpecs isEmpty not
		ifTrue: [
			projectSpecs isEmpty not | packageSpecs isEmpty not ifTrue: [ aStream cr ].
			aStream tab: indent; nextPutAll: 'spec '.
			groupSpecs size > 1 ifTrue: [ aStream cr; tab: indent + 1 ].
			1 to: groupSpecs size  do: [:index | 
				(groupSpecs at: index) configMethodCascadeOn: aStream last: index == groupSpecs size indent: indent + 1.
				index ~= groupSpecs size ifTrue: [ aStream tab: indent + 1 ]]].! !

!MetacelloMCVersionSpec methodsFor: 'printing' stamp: 'dkh 10/9/2009 20:40'!
configSpawnMethodOn: aStream indent: indent

	super configSpawnMethodOn: aStream indent: indent.
	self configPackagesSpecMethodOn: aStream indent: indent.! !

!MetacelloMCVersionSpec methodsFor: 'loading' stamp: 'dkh 10/9/2009 13:03'!
defaultPackageNames
	"if there is a package named 'default' (a group) then it defines the default package names,
	 otherwise answer a list of all of the package names in this version"

	self packages packageNamed: 'default' ifAbsent: [ ^self packageNames ].
	^#('default')! !

!MetacelloMCVersionSpec methodsFor: 'loading' stamp: 'DaleHenrichs 2/3/2010 16:12'!
expandToLoadableSpecNames: nameList

	^(self resolveToLoadableSpecs: nameList) collect: [:spec | spec name ]! !

!MetacelloMCVersionSpec methodsFor: 'testing' stamp: 'DaleHenrichs 2/5/2010 11:16'!
isAllLoadedToSpec
	"all projects and packages are loaded and match specification"

	^self 
		isPartiallyCurrent: true 
		useEquality: true 
		targetVersionStatus: #(allLoadedToSpec)! !

!MetacelloMCVersionSpec methodsFor: 'testing' stamp: 'DaleHenrichs 2/5/2010 13:27'!
isAllLoadedToSpecAgainst: resolvedPackageAndProjectNames
	"all projects and packages are loaded and match specification"

	^self 
		isPartiallyCurrent: true 
		singleMatch: false 
		operator: #= 
		targetVersionStatus: #(allLoadedToSpec) 
		against: resolvedPackageAndProjectNames! !

!MetacelloMCVersionSpec methodsFor: 'testing' stamp: 'DaleHenrichs 2/6/2010 09:40'!
isLoadedMatchConstraints
	"all loaded projects and packages match constraints (at least one package loaded)"
	
	^self 
		isPartiallyCurrent: false 
		useEquality: false 
		targetVersionStatus: #(allLoadedToSpec loadedToSpec loadedMatchConstraints)! !

!MetacelloMCVersionSpec methodsFor: 'testing' stamp: 'DaleHenrichs 2/6/2010 09:41'!
isLoadedMatchConstraintsAgainst: resolvedPackageAndProjectNames
	"all loaded projects and packages match constraints (at least one package loaded)"

	^self 
		isPartiallyCurrent: false 
		singleMatch: false 
		operator: nil
		targetVersionStatus: #(allLoadedToSpec loadedToSpec loadedMatchConstraints) 
		against: resolvedPackageAndProjectNames! !

!MetacelloMCVersionSpec methodsFor: 'testing' stamp: 'DaleHenrichs 2/6/2010 09:41'!
isLoadedToSpec
	"all loaded projects and packages match specifications (at least one package loaded)"
	
	^self 
		isPartiallyCurrent: false 
		useEquality: true 
		targetVersionStatus: #(allLoadedToSpec loadedToSpec)! !

!MetacelloMCVersionSpec methodsFor: 'testing' stamp: 'DaleHenrichs 2/6/2010 09:41'!
isLoadedToSpecAgainst: resolvedPackageAndProjectNames
	"all loaded projects and packages match specifications (at least one package loaded)"

	^self 
		isPartiallyCurrent: false 
		singleMatch: false 
		operator: #= 
		targetVersionStatus: #(allLoadedToSpec loadedToSpec) 
		against: resolvedPackageAndProjectNames! !

!MetacelloMCVersionSpec methodsFor: 'testing' stamp: 'DaleHenrichs 2/8/2010 17:10'!
isPartiallyCurrent: notLoadedMatters singleMatch: singleMatch operator: operator targetVersionStatus: targetVersionStatus against: resolvedPackageAndProjectNames

	| hasNoPackage hasNoProject aProjectIsLoaded aPackageIsLoaded mcLoader  aLoadedProjectIsCurrent aLoadedPackageIsCurrent aLoadedProjectIsNotCurrent aLoadedPackageIsNotCurrent aProjectNotLoaded aPackageNotLoaded |
	hasNoPackage := hasNoProject := true.
	aProjectIsLoaded := aPackageIsLoaded := false.
	aLoadedProjectIsCurrent := aLoadedPackageIsCurrent := false.
	aLoadedProjectIsNotCurrent := aLoadedPackageIsNotCurrent := false.
	aProjectNotLoaded := aPackageNotLoaded := false.
	mcLoader := self loader.
	self 
		specsNamed: resolvedPackageAndProjectNames
		projectDo: [:prj | | vrsn currentVersion |
			hasNoProject := false.
			vrsn := prj version.
			vrsn ~~ nil
				ifTrue: [ 
					(currentVersion := prj relativeCurrentVersion) ~~ nil
						ifTrue: [ (targetVersionStatus includes: currentVersion versionStatus) ifFalse: [ ^false ]]].
			currentVersion ~~ nil
				ifTrue: [
					 aProjectIsLoaded := true.
					(operator ~~ nil
						ifTrue: [ currentVersion perform: operator with: vrsn ]
						ifFalse: [ currentVersion perform: prj projectReference operator with: vrsn])
							ifTrue: [ aLoadedProjectIsCurrent := true. ]
							ifFalse: [ aLoadedProjectIsNotCurrent := true ]]
				ifFalse: [ aProjectNotLoaded := true ]] 
		packageDo: [:pkg | 
			hasNoPackage := false.
			pkg 
				currentPackageLoaded: [:isCurrent | 
					singleMatch ifTrue: [ ^true ].
					aPackageIsLoaded := true.
					isCurrent 
						ifTrue: [ aLoadedPackageIsCurrent := true ]
						ifFalse: [ aLoadedPackageIsNotCurrent := true ]] 
				comparing: (operator ~~ nil ifTrue: [ operator ] ifFalse: [ #>= ])
				notLoaded: [:ignored | aPackageNotLoaded := true ] 
				using: mcLoader ] 
		groupDo: [:ignoredGroup | 
			"if we encounter a group, return false"
			^false ].
	hasNoPackage & hasNoProject ifTrue: [ ^false ].
	^notLoadedMatters
		ifTrue: [ 
			(hasNoPackage or: [ aPackageIsLoaded & (aPackageNotLoaded not) & aLoadedPackageIsCurrent & (aLoadedPackageIsNotCurrent not) ]) and: [
				hasNoProject or: [ aProjectIsLoaded & (aProjectNotLoaded not) & aLoadedProjectIsCurrent & (aLoadedProjectIsNotCurrent not) ]]]
		ifFalse: [ 
			singleMatch ifTrue: [ ^false ]. "no single match for projects and packages exit early"
			aPackageIsLoaded & aProjectIsLoaded
				ifTrue: [
					^(aLoadedPackageIsCurrent & (aLoadedPackageIsNotCurrent not)) and: [
				 		aLoadedProjectIsCurrent & (aLoadedProjectIsNotCurrent not) ]].
			aPackageIsLoaded
				ifTrue: [
					^aLoadedPackageIsCurrent & (aLoadedPackageIsNotCurrent not) ].
			"aProjectIsLoaded == true"
			^hasNoPackage & aLoadedProjectIsCurrent & (aLoadedProjectIsNotCurrent not) ]! !

!MetacelloMCVersionSpec methodsFor: 'testing' stamp: 'DaleHenrichs 2/5/2010 12:51'!
isPartiallyCurrent: notLoadedMatters useEquality: useEquality singleMatch: singleMatch targetVersionStatus: targetVersionStatus

	^self 
		isPartiallyCurrent: notLoadedMatters 
		singleMatch: singleMatch
		operator: (useEquality ifTrue: [ #= ] ifFalse: [ nil ])
		targetVersionStatus: targetVersionStatus 
		against: (self expandToLoadableSpecNames: #('ALL'))! !

!MetacelloMCVersionSpec methodsFor: 'testing' stamp: 'DaleHenrichs 2/5/2010 12:49'!
isPartiallyCurrent: notLoadedMatters useEquality: useEquality targetVersionStatus: targetVersionStatus

	^self 
		isPartiallyCurrent: notLoadedMatters 
		useEquality: useEquality 
		targetVersionStatus: targetVersionStatus 
		against: (self expandToLoadableSpecNames: #('ALL'))! !

!MetacelloMCVersionSpec methodsFor: 'testing' stamp: 'DaleHenrichs 2/4/2010 16:01'!
isPartiallyCurrent: notLoadedMatters useEquality: useEquality targetVersionStatus: targetVersionStatus against: resolvedPackageAndProjectNames

	^ self 
		isPartiallyCurrent: notLoadedMatters 
		singleMatch: false
		operator: (useEquality ifTrue: [ #= ] ifFalse: [ nil ]) 
		targetVersionStatus: targetVersionStatus 
		against: resolvedPackageAndProjectNames! !

!MetacelloMCVersionSpec methodsFor: 'testing' stamp: 'DaleHenrichs 1/21/2010 13:26'!
isPossibleBaseline

	self 
		projectDo: [:prj | prj isPossibleBaseline ifFalse: [ ^false ]] 
		packageDo: [:pkg | pkg isPackageLoaded ifFalse: [ ^false ]] 
		groupDo: [:ignored | ].
	^true! !

!MetacelloMCVersionSpec methodsFor: 'testing' stamp: 'DaleHenrichs 2/6/2010 09:44'!
isSomethingLoaded
	"at least one package loaded"
	
	^self 
		isPartiallyCurrent: false 
		useEquality: false 
		singleMatch: true 
		targetVersionStatus: #(allLoadedToSpec loadedToSpec loadedMatchConstraints somethingLoaded)! !

!MetacelloMCVersionSpec methodsFor: 'testing' stamp: 'DaleHenrichs 2/6/2010 09:44'!
isSomethingLoadedAgainst: resolvedPackageAndProjectNames
	"at least one package loaded"

	^self 
		isPartiallyCurrent: false 
		singleMatch: true 
		operator: nil
		targetVersionStatus: #(allLoadedToSpec loadedToSpec loadedMatchConstraints somethingLoaded) 
		against: resolvedPackageAndProjectNames! !

!MetacelloMCVersionSpec methodsFor: 'merging' stamp: 'dkh 10/9/2009 07:34'!
mergeMap

	| map |
	map := super mergeMap.
	map at: #packages put: self packages.
	map at: #repositories put: self repositories.
	^map! !

!MetacelloMCVersionSpec methodsFor: 'merging' stamp: 'dkh 9/23/2009 11:54'!
mergeSpec: anotherSpec

	| newSpec map anotherPackages anotherRepositories |
	newSpec := super mergeSpec: anotherSpec.
	map := anotherSpec mergeMap.
	(anotherPackages := map at: #packages) isEmpty not 
		ifTrue: [ 
			newSpec 
				packages: (self packages isEmpty
					ifTrue: [ anotherPackages ]
					ifFalse: [ self packages mergeSpec: anotherPackages ]) ].
	(anotherRepositories := map at: #repositories) isEmpty not
		ifTrue: [ 
			newSpec 
				repositories: (self repositories isEmpty
					ifTrue: [ anotherRepositories ]
					ifFalse: [ self repositories mergeSpec: anotherRepositories ]) ].
	^newSpec! !

!MetacelloMCVersionSpec methodsFor: 'merging' stamp: 'dkh 9/23/2009 11:54'!
nonOverridable

	^super nonOverridable, #( packages repositories)! !

!MetacelloMCVersionSpec methodsFor: 'querying' stamp: 'dkh 10/21/2009 13:55'!
packageNamed: aString

	^self packageNamed: aString ifAbsent: [ nil ]! !

!MetacelloMCVersionSpec methodsFor: 'querying' stamp: 'DaleHenrichs 1/21/2010 15:52'!
packageNamed: aString forMap: map ifAbsent: aBlock

	| package |
	package := map
				at: aString
				ifAbsent: [].
	package == nil
		ifTrue: [
			(aString = 'default' or: [ aString = 'ALL'])
				ifTrue: [ 
					package := self project groupSpec name: aString;
				 		includes: self packageNames;					 
						yourself ]
				ifFalse: [ ^aBlock value ]].
	^package! !

!MetacelloMCVersionSpec methodsFor: 'querying' stamp: 'DaleHenrichs 1/21/2010 15:52'!
packageNamed: aString ifAbsent: aBlock

	^self packageNamed: aString forMap: self packages map ifAbsent: aBlock! !

!MetacelloMCVersionSpec methodsFor: 'querying' stamp: 'dkh 10/9/2009 12:59'!
packageNames

	packages == nil ifTrue: [ ^#() ].
	^self packageSpecsInLoadOrder collect: [:pkg | pkg name ]! !

!MetacelloMCVersionSpec methodsFor: 'accessing' stamp: 'dkh 6/17/2009 16:05'!
packages

	packages == nil ifTrue: [ packages := self project packagesSpec ].
	^ packages! !

!MetacelloMCVersionSpec methodsFor: 'accessing' stamp: 'dkh 6/7/2009 08:19'!
packages: anObject
	packages := anObject! !

!MetacelloMCVersionSpec methodsFor: 'development support' stamp: 'dkh 12/22/2009 09:56'!
packagesNeedSavingVisited: visitedProjects into: aCollection

	self packages map valuesDo: [:pkg | pkg packagesNeedSavingVisited: visitedProjects using: self repositories map values into: aCollection ].! !

!MetacelloMCVersionSpec methodsFor: 'querying' stamp: 'dkh 6/17/2009 16:06'!
packageSpecsInLoadOrder

	^self packages packageSpecsInLoadOrder! !

!MetacelloMCVersionSpec methodsFor: 'accessing' stamp: 'dkh 9/23/2009 17:16'!
packagesSpec

	^self packages! !

!MetacelloMCVersionSpec methodsFor: 'copying' stamp: 'dkh 10/9/2009 07:34'!
postCopy

	super postCopy.
	packages := packages copy.
	repositories := repositories copy.! !

!MetacelloMCVersionSpec methodsFor: 'enumerating' stamp: 'dkh 10/20/2009 17:16'!
projectDo: projectBlock packageDo: packageBlock groupDo: groupBlock

	self packageSpecsInLoadOrder do: [:pkgSpec |
		pkgSpec projectDo: projectBlock packageDo: packageBlock groupDo: groupBlock ]! !

!MetacelloMCVersionSpec methodsFor: 'accessing' stamp: 'dkh 6/17/2009 16:05'!
repositories
	repositories == nil ifTrue: [ repositories := self project repositoriesSpec ].
	^ repositories! !

!MetacelloMCVersionSpec methodsFor: 'accessing' stamp: 'dkh 6/7/2009 08:20'!
repositories: anObject
	repositories := anObject! !

!MetacelloMCVersionSpec methodsFor: 'accessing' stamp: 'dkh 9/23/2009 17:18'!
repositoriesSpec

	^self repositories! !

!MetacelloMCVersionSpec methodsFor: 'accessing' stamp: 'dkh 10/7/2009 16:27'!
repository: aString
	self repositoriesSpec add: aString! !

!MetacelloMCVersionSpec methodsFor: 'accessing' stamp: 'dkh 10/22/2009 14:24'!
repository: aString username: username password: password
	self repositoriesSpec repository: aString username: username password: password! !

!MetacelloMCVersionSpec methodsFor: 'loading' stamp: 'dkh 6/18/2009 10:13'!
repositorySpecs

	^self repositories map values! !

!MetacelloMCVersionSpec methodsFor: 'loading' stamp: 'DaleHenrichs 2/5/2010 22:24'!
resolveToLoadableSpec: aString forMap: map packages: packageMap 
	| package |
	package := self packageNamed: aString forMap: map ifAbsent: [ ^self error: 'Name not found: ' , aString ].
	packageMap at: package name put: package.
	^ {package}! !

!MetacelloMCVersionSpec methodsFor: 'loading' stamp: 'DaleHenrichs 2/3/2010 15:42'!
resolveToLoadableSpecs: nameList
	"Resolves names in namelist to the  list of packages and projects in the version that would be loaded. Projects are 
	not traversed during the transitive closure. The scope is that of the version itself.
	   If the spec is a package, answer a list including the package and the transitive closure on 
			its #requires: and #includes: fields.
	   If the spec is a project, answer the project.
	   If the spec is a group, answers the list of packages in the #includes: field of the group. 
			Groups in the #includes: field are expanded following the transitive closure on groups"

	| map |
	map := Dictionary new.
	self resolveToLoadableSpecs: nameList map: map.
	^map values! !

!MetacelloMCVersionSpec methodsFor: 'loading' stamp: 'DaleHenrichs 2/5/2010 22:25'!
resolveToLoadableSpecs: required map: packageMap 

	| reqd allReqd map |
	reqd := required copy.
	allReqd := Set new.
	map := self packages map.
	[ reqd isEmpty ] whileFalse: [ | newReqd |
		newReqd := Set new.
		reqd do: [:req | 
			(self resolveToLoadableSpec: req forMap: map packages: packageMap) 
				do: [:loadableSpec | 
					newReqd addAll: loadableSpec requires.
					newReqd addAll: loadableSpec includes ]].
		allReqd addAll: reqd.
		newReqd removeAllFoundIn: allReqd.
		reqd := newReqd ].
	packageMap keys do: [:pkgName | | spec |
		(spec := (packageMap at: pkgName) resolveToLoadableSpec) == nil
			ifTrue: [ packageMap removeKey: pkgName ]
			ifFalse: [ packageMap at: pkgName put: (packageMap at: pkgName) resolveToLoadableSpec ]]! !

!MetacelloMCVersionSpec methodsFor: 'enumerating' stamp: 'DaleHenrichs 01/20/2010 15:50'!
specsNamed: packageAndProjectNames projectDo: projectBlock packageDo: packageBlock groupDo: groupBlock

	| map |
	map := self packages map.
	packageAndProjectNames do: [:name | | pkgSpec |
		(pkgSpec := map at: name ifAbsent: [ ]) ~~ nil
			ifTrue: [ pkgSpec projectDo: projectBlock packageDo: packageBlock groupDo: groupBlock ]]! !

!MetacelloMCVersionSpec methodsFor: 'development support' stamp: 'dkh 10/5/2009 16:15'!
updatedPackageSpecs

	| updatedSpecs mcLoader |
	updatedSpecs := Dictionary new.
	mcLoader := self loader.
	self packages map valuesDo: [:pkg | pkg updatePackageSpec: updatedSpecs using: mcLoader].
	^updatedSpecs! !

!MetacelloMCVersionSpec methodsFor: 'private' stamp: 'dkh 10/7/2009 14:45'!
versionClass

	^MetacelloMCVersion! !

!MCVersionLoader methodsFor: '*metacello-mc' stamp: 'dkh 9/9/2009 14:51'!
versions

	^versions! !

GoferPackageReference subclass: #MetacelloGoferPackage
	instanceVariableNames: 'packageFilename version workingCopy'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metacello-MC-Gofer'!

!MetacelloGoferPackage class methodsFor: 'instance creation' stamp: 'dkh 12/15/2009 10:32'!
name: aString packageFilename: packageFilename
	^ self basicNew initializeName: aString packageFilename: packageFilename! !

!MetacelloGoferPackage class methodsFor: 'package name matching' stamp: 'DaleHenrichs 3/18/2010 16:54'!
packageFileName: pkgFileName matchesPackageName: wcPkgName

	^(pkgFileName beginsWith: wcPkgName) 
		ifTrue: [ 
			(pkgFileName size = wcPkgName size) 
			or: [ ((pkgFileName at: wcPkgName size + 1) = $-) 
				or: [ ((pkgFileName at: wcPkgName size + 1) = $.) 
					or: [ (pkgFileName at: wcPkgName size + 1) isDigit ]]]]
		ifFalse: [
			pkgFileName size >= wcPkgName size ifTrue: [ ^false ].
			(wcPkgName beginsWith: pkgFileName) ifFalse: [ ^false ].
			^(wcPkgName at: pkgFileName size + 1) = $. ]! !

!MetacelloGoferPackage methodsFor: 'querying' stamp: 'dkh 9/25/2009 11:26'!
currentVersionInfo

	| wc |
	(wc := self workingCopy) ~~ nil
		ifTrue: [ 
			wc ancestry ancestors isEmpty not
				ifTrue: [ ^wc ancestry ancestors first ]].
	^nil! !

!MetacelloGoferPackage methodsFor: 'private' stamp: 'dkh 10/15/2009 10:48'!
findWorkingCopy
	"Answer a working copy, or nil if the package is not loaded."

	| wcs |
	wcs := MCWorkingCopy allManagers select: [ :each | self matchesWorkingCopy: each ].
	wcs isEmpty ifTrue: [ ^nil ].
	^wcs detectMax: [:ea | ea package name size ]! !

!MetacelloGoferPackage methodsFor: 'initialization' stamp: 'dkh 12/15/2009 10:31'!
initializeName: aString packageFilename: packagefilename

	name := aString.
	packageFilename := packagefilename! !

!MetacelloGoferPackage methodsFor: 'private' stamp: 'DaleHenrichs 3/19/2010 10:04'!
matches: aLoadableReference
	"does Monticello-style #versionInfoFromVersionNamed: matching"
	
	| pFilename |
	(((pFilename := self packageFilename) == nil) or: [ self name = self packageFilename] ) ifTrue: [ ^super matches: aLoadableReference ].
	^aLoadableReference name beginsWith: pFilename! !

!MetacelloGoferPackage methodsFor: 'private' stamp: 'dkh 12/15/2009 10:26'!
matchesWorkingCopy: aWorkingCopy
	"check that the working copy package name matches the package file name and that the first ancestor's package file name
	 matches the packageName"
	
	| pFilename |
	(pFilename := self packageFilename) == nil ifTrue: [ ^super matchesWorkingCopy: aWorkingCopy ].
	(self class 
		packageFileName: pFilename 
		matchesPackageName: aWorkingCopy package name)
			ifTrue: [
				aWorkingCopy ancestry ancestors isEmpty ifTrue: [ ^true ].
				^self class 
					packageFileName: aWorkingCopy ancestry ancestors first name 
					matchesPackageName: self packageName ].
	^false! !

!MetacelloGoferPackage methodsFor: 'accessing' stamp: 'dkh 10/12/2009 16:25'!
packageFilename

	^packageFilename! !

!MetacelloGoferPackage methodsFor: 'accessing' stamp: 'dkh 10/15/2009 10:00'!
workingCopy
	
	workingCopy == nil ifTrue: [ workingCopy := self findWorkingCopy ].
	^workingCopy! !

!BlockClosure methodsFor: '*metacello-mc' stamp: 'DaleHenrichs 1/16/2010 11:42'!
valueSupplyingMetacelloAnswers: aListOfPairs
	"evaluate the block using a list of questions / answers that might be called upon to
	automatically respond to Object>>confirm: or FillInTheBlank requests"

	^ [self value] 
		on: ProvideAnswerNotification
		do: 
			[:notify | | answer caption |
			
			caption := notify messageText withSeparatorsCompacted. "to remove new lines"
			answer := aListOfPairs
				detect: 
					[:each | caption = each first or:
						[(caption includesSubstring: each first caseSensitive: false) or:
						[(each first match: caption) or:
						[(String includesSelector: #matchesRegex:) and: 
						[ [ caption matchesRegex: each first ] on: Error do: [:ignored | false ]]]]]]
					ifNone: [nil].
			answer
				ifNotNil: [notify resume: answer second]
				ifNil: 
					[ | outerAnswer |
					outerAnswer := ProvideAnswerNotification signal: notify messageText.
					outerAnswer 
						ifNil: [notify resume] 
						ifNotNil: [notify resume: outerAnswer]]]! !

GoferLoad subclass: #MetacelloGoferLoad
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metacello-MC-Gofer'!

!MetacelloGoferLoad methodsFor: 'private' stamp: 'DaleHenrichs 3/5/2010 10:48'!
updateRepositories
	"Noop for Metacello...done by loader itself"! !

MetacelloVersion subclass: #MetacelloMCVersion
	instanceVariableNames: 'loaderPolicy'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metacello-MC-Model'!

!MetacelloMCVersion methodsFor: 'querying' stamp: 'dkh 10/21/2009 19:15'!
allPackagesForSpecNamed: aStringOrArray
	"resolves list of packages associated with the named spec.
	   If the spec is a packages, answer a list including the package and the transitive closure on 
			its #requires: and #includes: fields.
	   If the spec is a project, answer a list of the packages associated with the project,
			following the transitive closure on packages reachable starting with the #loads: field.
	   If the spec is a group, answers the list of packages in the #includes: field of the group. 
			Groups in the #includes: field are expanded following the transitive closure on groups"
	"In essence, this query answers the list of all packages that would be loaded if the package 
		named <aString> were loaded."
	"If there is no spec named <aString>, answers an empty list"

	^self allPackagesForSpecNamed: aStringOrArray ifAbsent: [ ^#() ]! !

!MetacelloMCVersion methodsFor: 'querying' stamp: 'dkh 10/21/2009 19:16'!
allPackagesForSpecNamed: aStringOrArray ifAbsent: aBlock
	"resolves list of packages associated with the named spec.
	   If the spec is a packages, answer a list including the package and the transitive closure on 
			its #requires: and #includes: fields.
	   If the spec is a project, answer a list of the packages associated with the project,
			following the transitive closure on packages reachable starting with the #loads: field.
	   If the spec is a group, answers the list of packages in the #includes: field of the group. 
			Groups in the #includes: field are expanded following the transitive closure on groups"
	"In essence, this query answers the list of all packages that would be loaded if the package 
		named <aString> were loaded."
	"If there is no spec named <aString>, aBlock is evaluated"

	^aStringOrArray 
		resolvePackageSpecsNamedForMetacelloMCVersion: self 
		visited: MetacelloVisitedPackages new 
		ifAbsent: aBlock! !

!MetacelloMCVersion methodsFor: 'private' stamp: 'dkh 10/21/2009 19:17'!
allPackagesForSpecs: pkgSpecs visited: visited

 
	| coll |
	coll := Dictionary new.
	pkgSpecs
		do: [:pkgSpec | (pkgSpec resolveToAllPackagesIn: self spec visited: visited)
				do: [:pkg | coll at: pkg name put: pkg ]].
	^ coll values asOrderedCollection! !

!MetacelloMCVersion methodsFor: 'accessing' stamp: 'DaleHenrichs 3/29/2010 15:32'!
cacheRepository: repository 
	"by default cacheRepository is an MCDictionaryRepository"
	
	self loaderPolicy cacheRepository: repository! !

!MetacelloMCVersion methodsFor: 'private' stamp: 'DaleHenrichs 4/9/2010 14:48'!
doFetchRequiredFromArray: anArray

	| oldPolicy oldBypassProgress displayString |
	displayString := self versionNumber printString, ' of ', self spec projectLabel.
	Transcript cr; show: 'Fetching ', displayString, '...'.
	oldPolicy := loaderPolicy. 
	oldBypassProgress := MetacelloPlatform current bypassProgressBars.
	self loaderPolicy silently ifTrue: [ MetacelloPlatform current bypassProgressBars: true ].
	[ 	| ans |
		ans := self fetchRequiredFromArray: anArray.
		Transcript cr; show: '...finished ', self versionNumber printString.
		^ans ]
			ensure: [ 
				MetacelloPlatform current bypassProgressBars: oldBypassProgress.
				loaderPolicy := oldPolicy ]! !

!MetacelloMCVersion methodsFor: 'private' stamp: 'DaleHenrichs 4/9/2010 14:48'!
doLoadRequiredFromArray: anArray

	| displayString oldPolicy oldBypassProgress |
	displayString := self versionNumber printString, ' of ', self spec projectLabel.
	Transcript cr; show: 'Loading ', displayString, '...'.
	oldPolicy := loaderPolicy. 
	oldBypassProgress := MetacelloPlatform current bypassProgressBars.
	self loaderPolicy silently ifTrue: [ MetacelloPlatform current bypassProgressBars: true ].
	[	| fetchLoader |
		fetchLoader := self fetchRequiredFromArray: anArray.
		MetacelloPlatform current
			do:  [  fetchLoader doLoad ]
			displaying: 'Loading ', displayString.
		Transcript cr; show: '...finished ', self versionNumber printString.
		^fetchLoader ]
		ensure: [ 
			MetacelloPlatform current bypassProgressBars: oldBypassProgress.
			loaderPolicy := oldPolicy ]! !

!MetacelloMCVersion methodsFor: 'private' stamp: 'DaleHenrichs 4/9/2010 14:48'!
doRecordRequiredFromArray: anArray

	| originalLoader oldPolicy displayString oldBypassProgress |
	displayString := self versionNumber printString, ' of ', self spec projectLabel.
	Transcript cr; show: 'Recording ', displayString, '...'.
	originalLoader := self versionSpec loader.
	oldPolicy := loaderPolicy. 
	oldBypassProgress := MetacelloPlatform current bypassProgressBars.
	self loaderPolicy silently ifTrue: [ MetacelloPlatform current bypassProgressBars: true ].
	[	MetacelloPlatform current
			do:  [ | ans |
				self versionSpec loader: originalLoader recordingSpecLoader.
				ans := (self executeLoadFromArray: anArray) copy.
				Transcript cr; show: '...finished ', self versionNumber printString.
				^ans ]
			displaying: 'Recording ', displayString ]
				ensure: [
					MetacelloPlatform current bypassProgressBars: oldBypassProgress.
					self versionSpec loader: originalLoader.
					loaderPolicy := oldPolicy ]! !

!MetacelloMCVersion methodsFor: 'private' stamp: 'DaleHenrichs 3/6/2010 08:35'!
executeLoadFromArray: anArray

	| loader mcLoader |
	loader := MetacelloMCVersionSpecLoader on: self spec.
	loader required: anArray.
	loaderPolicy notNil ifTrue: [ loader loaderPolicy: loaderPolicy ].
	mcLoader := loader load.
	mcLoader doingLoads: [ self project configuration class metacelloVersion: self versionString loads: anArray ].
	^mcLoader! !

!MetacelloMCVersion methodsFor: 'querying' stamp: 'DaleHenrichs 2/4/2010 10:32'!
expandToLoadableSpecNames: nameList
	"Just like #resolveToLoadableSpecs:, but returns list of spec names instead of specs"
	
	^self spec expandToLoadableSpecNames: nameList! !

!MetacelloMCVersion methodsFor: 'actions' stamp: 'DaleHenrichs 3/7/2010 08:25'!
fetch

	^self doFetchRequiredFromArray: self spec defaultPackageNames! !

!MetacelloMCVersion methodsFor: 'actions' stamp: 'DaleHenrichs 3/7/2010 08:25'!
fetch: required

	^required fetchRequiredForMetacelloMCVersion: self! !

!MetacelloMCVersion methodsFor: 'private' stamp: 'DaleHenrichs 3/11/2010 16:34'!
fetchRequiredFromArray: anArray

	| originalLoader displayString newLoader |
	originalLoader := self versionSpec loader.
	newLoader := originalLoader fetchingSpecLoader.
	displayString := newLoader actionLabel, self versionNumber printString, ' of ', self spec projectLabel.
	MetacelloPlatform current
		do:  [
			[	self versionSpec loader: newLoader.
				^self executeLoadFromArray: anArray ]
					ensure: [ self versionSpec loader: originalLoader]]
		displaying: displayString! !

!MetacelloMCVersion methodsFor: 'querying' stamp: 'dkh 10/21/2009 14:37'!
groups
	"Answers the list of groups associated with this version"
	
	| groups |
	groups := OrderedCollection new.
	self spec projectDo: [:ignored | ] packageDo: [:ignored | ] groupDo: [:grp | groups add: grp ].
	^groups! !

!MetacelloMCVersion methodsFor: 'accessing' stamp: 'DaleHenrichs 3/29/2010 15:31'!
ignoreImage: aBool 
	"by default ignoreImage is false"
	
	self loaderPolicy ignoreImage: aBool! !

!MetacelloMCVersion methodsFor: 'actions' stamp: 'DaleHenrichs 3/4/2010 15:37'!
load

	^self doLoadRequiredFromArray: self spec defaultPackageNames! !

!MetacelloMCVersion methodsFor: 'actions' stamp: 'dkh 6/15/2009 22:34'!
load: required

	^required loadRequiredForMetacelloMCVersion: self! !

!MetacelloMCVersion methodsFor: 'private' stamp: 'dkh 6/18/2009 10:12'!
loader: aLoader

	self versionSpec loader: aLoader! !

!MetacelloMCVersion methodsFor: 'accessing' stamp: 'DaleHenrichs 3/6/2010 08:21'!
loaderPolicy

	loaderPolicy == nil ifTrue: [ loaderPolicy := MetacelloLoaderPolicy new ].
	^ loaderPolicy! !

!MetacelloMCVersion methodsFor: 'accessing' stamp: 'DaleHenrichs 3/6/2010 08:20'!
loaderPolicy: anObject
	loaderPolicy := anObject! !

!MetacelloMCVersion methodsFor: 'private' stamp: 'DaleHenrichs 3/11/2010 14:06'!
loadRequiredFromArray: anArray

	| displayString |
	displayString := 'Loading ', self versionNumber printString, ' of ', self spec projectLabel.
	MetacelloPlatform current
		do: [ ^self executeLoadFromArray: anArray ]
		displaying: displayString! !

!MetacelloMCVersion methodsFor: 'querying' stamp: 'dkh 10/24/2009 20:02'!
packageNamed: aString

	^self packageNamed: aString ifAbsent: [ ^nil ].! !

!MetacelloMCVersion methodsFor: 'querying' stamp: 'dkh 10/24/2009 20:04'!
packageNamed: aString ifAbsent: aBlock

	| pkg |
	(pkg := self spec packageNamed: aString ifAbsent: []) == nil
		ifTrue: [ ^aBlock value ].
	^pkg referencedSpec! !

!MetacelloMCVersion methodsFor: 'querying' stamp: 'dkh 10/21/2009 14:37'!
packages
	"Answers the list of packages associated with this version"

	| packages |
	packages := OrderedCollection new.
	self spec projectDo: [:ignored | ] packageDo: [:pkg | packages add: pkg ] groupDo: [:ignored | ].
	^packages! !

!MetacelloMCVersion methodsFor: 'querying' stamp: 'dkh 10/21/2009 15:06'!
packagesForSpecNamed: aString
	"resolves list of packages associated with the named spec.
	   If the spec is a packages, answer a list including only the package. #requires: and #includes:
			fields in the package are ignored.
	   If the spec is a project, answers an empty list.
	   If the spec is a group, answers the list of packages in the #includes: field of the group. 
			Groups in the #includes: field are expanded following the transitive closure on groups"
	"If there is no spec named <aString>, answers an empty list"

	^self packagesForSpecNamed: aString ifAbsent: [ ^#() ]! !

!MetacelloMCVersion methodsFor: 'querying' stamp: 'dkh 10/21/2009 15:20'!
packagesForSpecNamed: aString ifAbsent: aBlock
	"resolves list of packages associated with the named spec.
	   If the spec is a packages, answer a list including only the package. #requires: and #includes:
			fields in the package are ignored.
	   If the spec is a project, answers an empty list.
	   If the spec is a group, answers the list of packages in the #includes: field of the group. 
			Groups in the #includes: field are expanded following the transitive closure on groups"
	"If there is no spec named <aString>, aBlock is evaluated"

	| pkgSpec |
	pkgSpec := self spec packageNamed: aString ifAbsent: aBlock.
	^pkgSpec resolveToPackagesIn: self spec visited: MetacelloVisitedPackages new! !

!MetacelloMCVersion methodsFor: 'querying' stamp: 'dkh 10/24/2009 19:45'!
projects
	"Answers the list of projects associated with this version"

	| projects |
	projects := OrderedCollection new.
	self spec projectDo: [:prj | projects add: prj projectReference ] packageDo: [:ignored | ] groupDo: [:ignored | ].
	^projects! !

!MetacelloMCVersion methodsFor: 'actions' stamp: 'DaleHenrichs 3/11/2010 10:07'!
record

	^self doRecordRequiredFromArray: self spec defaultPackageNames! !

!MetacelloMCVersion methodsFor: 'actions' stamp: 'DaleHenrichs 3/11/2010 10:06'!
record: required

	^required recordRequiredForMetacelloMCVersion: self! !

!MetacelloMCVersion methodsFor: 'accessing' stamp: 'DaleHenrichs 3/7/2010 08:11'!
repositoryOverrides: repositoriesCollection 

	self loaderPolicy overrideRepositories: repositoriesCollection! !

!MetacelloMCVersion methodsFor: 'querying' stamp: 'DaleHenrichs 2/3/2010 15:43'!
resolveToLoadableSpecs: nameList
	"Resolves names in namelist to the  list of packages and projects in the version that would be loaded. Projects are 
	not traversed during the transitive closure. The scope is that of the version itself.
	   If the spec is a package, answer a list including the package and the transitive closure on 
			its #requires: and #includes: fields.
	   If the spec is a project, answer the project.
	   If the spec is a group, answers the list of packages in the #includes: field of the group. 
			Groups in the #includes: field are expanded following the transitive closure on groups"

	^self spec resolveToLoadableSpecs: nameList! !

!MetacelloMCVersion methodsFor: 'accessing' stamp: 'DaleHenrichs 3/29/2010 15:32'!
silently: aBool 
	"by default silently is false"
	
	self loaderPolicy silently: aBool! !

!MetacelloAbstractPackageSpec methodsFor: '*metacello-mc-querying' stamp: 'dkh 8/18/2009 11:42'!
file 
	"MetacelloPackageSpec compatibility"
	
	^nil! !

!MetacelloAbstractPackageSpec methodsFor: '*metacello-mc-querying' stamp: 'DaleHenrichs 01/20/2010 13:40'!
isPackageLoaded

	^false! !

!MetacelloAbstractPackageSpec methodsFor: '*metacello-mc' stamp: 'DaleHenrichs 3/5/2010 09:46'!
loadUsing: aLoader gofer: gofer

	^self subclassResponsibility! !

!MetacelloAbstractPackageSpec methodsFor: '*metacello-mc' stamp: 'dkh 11/12/2009 16:57'!
packageRepository
	
	^nil! !

!MetacelloAbstractPackageSpec methodsFor: '*metacello-mc' stamp: 'dkh 12/22/2009 09:56'!
packagesNeedSavingVisited: visitedProjects using: repos into: aCollection
	"noop by default"! !

!MetacelloAbstractPackageSpec methodsFor: '*metacello-mc-querying' stamp: 'dkh 6/23/2009 13:55'!
repository
	
	^nil! !

!MetacelloAbstractPackageSpec methodsFor: '*metacello-mc' stamp: 'dkh 08/03/2009 12:40'!
repositorySpecs

	^#()! !

!MetacelloAbstractPackageSpec methodsFor: '*metacello-mc' stamp: 'dkh 10/21/2009 15:50'!
resolveToAllPackagesIn: aVersionSpec into: packages visited: visited

	visited
		visit: self
		doing: [:spec |
			self visitingWithPackages: packages.
			(spec includes, spec requires) do: [:pkgName |
				(aVersionSpec packageNamed: pkgName)
					projectDo: [:prj | 
						(prj resolveToAllPackagesIn: aVersionSpec visited: visited) do: [:pkg | 
							packages at: pkg name put: pkg ]] 
					packageDo: [:pkg | 
						packages at: pkg name put: pkg.
						(pkg resolveToAllPackagesIn: aVersionSpec visited: visited) do: [:rpkg | 
							packages at: rpkg name put: rpkg ] ] 
					groupDo: [:grp | grp resolveToAllPackagesIn: aVersionSpec into: packages  visited: visited ]]]! !

!MetacelloAbstractPackageSpec methodsFor: '*metacello-mc' stamp: 'dkh 10/21/2009 15:37'!
resolveToAllPackagesIn: aVersionSpec visited: visited

	| packages |
	packages := Dictionary new.
	self resolveToAllPackagesIn: aVersionSpec into: packages visited: visited.
	^packages values asOrderedCollection! !

!MetacelloAbstractPackageSpec methodsFor: '*metacello-mc' stamp: 'dkh 10/6/2009 15:02'!
resolveToLoadableSpec

	^self! !

!MetacelloAbstractPackageSpec methodsFor: '*metacello-mc' stamp: 'dkh 10/21/2009 15:22'!
resolveToPackagesIn: aVersionSpec visited: visited

	^self subclassResponsibility! !

!MetacelloAbstractPackageSpec methodsFor: '*metacello-mc' stamp: 'DaleHenrichs 1/21/2010 21:03'!
updateForSpawnMethod: sourceSpec

	answers := name := requires := includes := nil! !

!MetacelloAbstractPackageSpec methodsFor: '*metacello-mc' stamp: 'dkh 08/03/2009 13:19'!
updatePackageRepositoriesFor: aVersionSpec
	"noop by default"
	
	^true! !

!MetacelloAbstractPackageSpec methodsFor: '*metacello-mc' stamp: 'dkh 10/5/2009 16:16'!
updatePackageSpec: updatedSpecs using: anMCLoader
	"Add pkg copy to updatedSpecs if the file in current image is different from the receiver's file"! !

!MetacelloAbstractPackageSpec methodsFor: '*metacello-mc-querying' stamp: 'dkh 10/24/2009 10:43'!
version 
	"MetacelloPackageSpec compatibility"
	
	^nil! !

!MetacelloAbstractPackageSpec methodsFor: '*metacello-mc' stamp: 'dkh 10/21/2009 15:50'!
visitingWithPackages: packages
	"noop"! !

MetacelloAbstractPackageSpec subclass: #MetacelloPackageSpec
	instanceVariableNames: 'file repositories goferPackage preLoadDoIt postLoadDoIt'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metacello-MC-Specs'!

!MetacelloPackageSpec methodsFor: 'testing' stamp: 'DaleHenrichs 2/5/2010 11:36'!
compareCurrentVersion: anOperator targetVersionStatus: statusIgnored using: anMCLoader

	self 
		currentPackageLoaded: [:bool | ^bool ] 
		comparing: anOperator 
		notLoaded: [:ignored | ^false ]
		using: anMCLoader! !

!MetacelloPackageSpec methodsFor: 'testing' stamp: 'DaleHenrichs 2/5/2010 14:03'!
compareRelativeCurrentVersion: anOperator targetVersionStatus: statusIgnored using: anMCLoader

	^self compareCurrentVersion: anOperator targetVersionStatus: statusIgnored using: anMCLoader! !

!MetacelloPackageSpec methodsFor: 'printing' stamp: 'dkh 1/6/2010 18:39'!
configMethodBodyOn: aStream hasName: hasName indent: indent

	| hasFile hasRepositories hasPreLoadDoIt hasPostLoadDoIt hasRequiresOrIncludesOrAnswers |
	hasFile := file ~~ nil.
	hasRepositories := self repositorySpecs size > 0.
	hasPreLoadDoIt := self preLoadDoIt ~~ nil.
	hasPostLoadDoIt := self postLoadDoIt ~~ nil.
	hasRequiresOrIncludesOrAnswers := (self requires isEmpty and: [ self includes isEmpty and: [self answers isEmpty ]]) not.
	hasRequiresOrIncludesOrAnswers
		ifTrue: [ 
			self 
				configMethodBodyOn: aStream 
				hasName: hasName 
				cascading: hasFile | hasRepositories | hasPreLoadDoIt | hasPostLoadDoIt
				indent: indent ].
	self 
		configMethodOn: aStream 
		for: file 
		selector: 'file: ' 
		cascading: hasName | hasRepositories | hasPreLoadDoIt | hasPostLoadDoIt | hasRequiresOrIncludesOrAnswers 
		cascade: hasRepositories | hasPreLoadDoIt | hasPostLoadDoIt 
		indent: indent.
	hasRepositories
		ifTrue: [ 
			(self repositorySpecs size > 1)
				ifTrue: [ 
					hasName | hasFile | hasPreLoadDoIt | hasPostLoadDoIt | hasRequiresOrIncludesOrAnswers
						ifTrue: [ aStream cr ]
						ifFalse: [ 
							aStream
								tab: indent; 
								nextPutAll: 'spec '].
					aStream 
						tab: indent; 
						nextPutAll: 'repositories: ['; 
						cr;
						tab: indent + 1;
						nextPutAll: 'spec'; 
						cr.
					self repositories configMethodCascadeOn: aStream indent: indent + 1.
					aStream nextPutAll: ' ]' ]
				ifFalse: [ 
					hasName | hasFile | hasPreLoadDoIt | hasPostLoadDoIt | hasRequiresOrIncludesOrAnswers
						ifTrue: [ aStream cr; tab: indent ].
					self repositories configMethodCascadeOn: aStream indent: indent ].
			hasPostLoadDoIt | hasPostLoadDoIt ifTrue: [ aStream nextPut: $; ] ].
	self 
		configMethodOn: aStream 
		for: self preLoadDoIt 
		selector: 'preLoadDoIt: '
		cascading: hasName | hasFile | hasRepositories | hasPostLoadDoIt | hasRequiresOrIncludesOrAnswers 
		cascade: hasPostLoadDoIt 
		indent: indent.
	self 
		configMethodOn: aStream 
		for: self postLoadDoIt 
		selector: 'postLoadDoIt: ' 
		cascading: hasName | hasFile | hasRepositories | hasPreLoadDoIt | hasRequiresOrIncludesOrAnswers 
		cascade: false 
		indent: indent.
	aStream nextPut: $.! !

!MetacelloPackageSpec methodsFor: 'printing' stamp: 'dkh 10/7/2009 09:36'!
configMethodCascadeOn: aStream member: aMember last: lastCascade indent: indent

	aMember methodUpdateSelector  == #remove:
		ifTrue: [ aStream  nextPutAll: 'removePackage: ', self name printString ]
		ifFalse: [ self configShortCutMethodBodyOn: aStream member: aMember indent: indent ].
	lastCascade
		ifTrue: [ aStream nextPut: $. ]
		ifFalse: [ aStream nextPut: $;; cr ]! !

!MetacelloPackageSpec methodsFor: 'printing' stamp: 'dkh 1/6/2010 18:05'!
configMethodOn: aStream indent: indent

	| hasRepositories hasPreLoadDoIt hasPostLoadDoIt hasRequiresOrIncludesOrAnswers hasFile |
	hasFile := file ~~ nil.
	hasRepositories := self repositorySpecs size > 0.
	hasPreLoadDoIt := self preLoadDoIt ~~ nil.
	hasPostLoadDoIt := self postLoadDoIt ~~ nil.
	hasRequiresOrIncludesOrAnswers := (self requires isEmpty and: [ self includes isEmpty and: [self answers isEmpty ]]) not.
	aStream tab: indent; nextPutAll: 'spec '.
	hasFile | hasRepositories | hasPreLoadDoIt | hasPostLoadDoIt | hasRequiresOrIncludesOrAnswers
		ifTrue: [
			aStream cr; tab: indent + 1; nextPutAll: 'name: ', self name printString; nextPut: $;.
			self configMethodBodyOn: aStream hasName: true indent: indent + 1 ]
		ifFalse: [
			aStream nextPutAll: 'name: ', self name printString ]! !

!MetacelloPackageSpec methodsFor: 'printing' stamp: 'dkh 1/6/2010 18:05'!
configShortCutMethodBodyOn: aStream member: aMember indent: indent

	| hasFile hasRepositories hasPreLoadDoIt hasPostLoadDoIt hasRequiresOrIncludesOrAnswers |
	hasFile := file ~~ nil.
	hasRepositories := self repositorySpecs size > 0.
	hasPreLoadDoIt := self preLoadDoIt ~~ nil.
	hasPostLoadDoIt := self postLoadDoIt ~~ nil.
	hasRequiresOrIncludesOrAnswers := (self requires isEmpty and: [ self includes isEmpty and: [self answers isEmpty ]]) not.
	hasRepositories | hasPreLoadDoIt | hasPostLoadDoIt | hasRequiresOrIncludesOrAnswers
		ifTrue: [
			aStream 
				nextPutAll: 'package: ', self name printString, ' ';
				nextPutAll: aMember methodUpdateSelector asString, ' ['; cr.
			aStream tab: indent + 1; nextPutAll: 'spec '.
			self configMethodBodyOn: aStream hasName: false indent: indent + 2.
			aStream nextPutAll: ' ]'.
			^self ].
	aStream nextPutAll: 'package: ', self name printString.
	hasFile
		ifTrue: [ aStream nextPutAll: ' with: ', file printString ]! !

!MetacelloPackageSpec methodsFor: 'testing' stamp: 'DaleHenrichs 4/15/2010 11:47'!
currentPackageLoaded: loadedBlock comparing: comarisonOperator notLoaded: notLoadedBlock using: anMCLoader	
	"Use currentVersionInfoFor: because it involves the loader and returns versionInfo for a planned load 
	 (atomic loaders) or currently loaded package"

	| vi wcName |
	vi := anMCLoader currentVersionInfoFor: self.
	vi notNil
		ifTrue: [ | fileRef wcRef |
			self getFile == nil ifTrue: [ ^loadedBlock value: false ].
			wcName := vi name.
			fileRef := GoferResolvedReference name: self file.
			wcRef := GoferResolvedReference name: wcName.
			^loadedBlock value: (wcRef compare: fileRef using: comarisonOperator) ].
	^notLoadedBlock value: true! !

!MetacelloPackageSpec methodsFor: 'gofer' stamp: 'dkh 9/25/2009 11:26'!
currentVersionInfo

	^self goferPackage currentVersionInfo! !

!MetacelloPackageSpec methodsFor: 'loading' stamp: 'DaleHenrichs 3/5/2010 19:05'!
ensureLoadedForDevelopmentUsing: mcLoader
	"noop"
	
	^true! !

!MetacelloPackageSpec methodsFor: 'loading' stamp: 'DaleHenrichs 3/21/2010 13:22'!
explicitLoadUsing: mcLoader

	| wc fetchingSpecLoader |
	((wc := self workingCopy) ~~ nil and: [ wc needsSaving ]) 
		ifTrue: [ 
			Transcript cr; show: 'Skipping load of modified package: ', self file.
			^self ].
	"fetch and explicitly load it"
	fetchingSpecLoader := mcLoader fetchingSpecLoader.
	fetchingSpecLoader
		explicitLoadPackageSpecs: (Array with: self) 
		repositories: (fetchingSpecLoader repositoriesFrom: self repositorySpecs).! !

!MetacelloPackageSpec methodsFor: 'private' stamp: 'dkh 10/7/2009 01:09'!
extractNameFromFile

	file == nil ifTrue: [ ^nil ].
	^(self loader nameComponentsFrom: self file) first! !

!MetacelloPackageSpec methodsFor: 'loading' stamp: 'DaleHenrichs 3/7/2010 09:36'!
fetch

	self fetchUsing: self loader! !

!MetacelloPackageSpec methodsFor: 'loading' stamp: 'DaleHenrichs 4/12/2010 13:57'!
fetchPackage: aLoaderPolicy

	self fetchUsing: 
		(self loader
			loaderPolicy: aLoaderPolicy;
			yourself)! !

!MetacelloPackageSpec methodsFor: 'loading' stamp: 'DaleHenrichs 3/7/2010 09:38'!
fetchUsing: mcLoader

	| fetchingSpecLoader |
	fetchingSpecLoader := mcLoader fetchingSpecLoader.
	fetchingSpecLoader
		linearLoadPackageSpecs: (Array with: self) 
		repositories: (fetchingSpecLoader repositoriesFrom: self repositorySpecs).! !

!MetacelloPackageSpec methodsFor: 'querying' stamp: 'dkh 10/6/2009 15:12'!
file

	file == nil ifTrue: [ ^self name ].
	^file! !

!MetacelloPackageSpec methodsFor: 'accessing' stamp: 'dkh 06/03/2009 12:11'!
file: aString

	file := aString! !

!MetacelloPackageSpec methodsFor: 'accessing' stamp: 'dkh 10/30/2009 10:37'!
getFile
	"raw access to iv"
	
	^file! !

!MetacelloPackageSpec methodsFor: 'development support' stamp: 'DaleHenrichs 3/15/2010 11:38'!
goferCommitPackage: commitMessage
	"uses gofer to do commit ... non-interactive"
	
	| latestFile pkgSpec |
	^(file notNil and: [ self name = self file ])
		ifTrue: [
			latestFile := self loader latestPackage: self name fromRepository: self repositorySpecs.
			pkgSpec := self copy.
			pkgSpec file: latestFile.
			pkgSpec goferCommitPackage: commitMessage ]
		ifFalse: [ self loader goferCommitPackageUsing: self repositorySpecs commitMessage: commitMessage ]! !

!MetacelloPackageSpec methodsFor: 'accessing' stamp: 'dkh 1/13/2010 17:04'!
goferLoaderReference

	^file == nil 
		ifTrue: [ GoferPackageReference name: self name ]
		ifFalse: [ 
			"does Monticello-style #versionInfoFromVersionNamed: matching"
			MetacelloGoferPackage name: self name packageFilename: self file ]! !

!MetacelloPackageSpec methodsFor: 'accessing' stamp: 'dkh 12/15/2009 10:32'!
goferPackage

	goferPackage == nil 
		ifTrue: [ goferPackage := MetacelloGoferPackage name: self name packageFilename: self file ].
	^goferPackage! !

!MetacelloPackageSpec methodsFor: 'private' stamp: 'dkh 10/10/2009 11:00'!
includesForPackageOrdering

	^self includes! !

!MetacelloPackageSpec methodsFor: 'accessing' stamp: 'dkh 1/6/2010 17:58'!
info
	"test compatibility method"

	^self! !

!MetacelloPackageSpec methodsFor: 'querying' stamp: 'dkh 5/14/2010 15:50'!
isPackageLoaded

	^self isPackageLoaded: self loader! !

!MetacelloPackageSpec methodsFor: 'querying' stamp: 'dkh 5/14/2010 15:50'!
isPackageLoaded: aLoader

	^(self workingCopyNameFor: aLoader) ~~ nil! !

!MetacelloPackageSpec methodsFor: 'loading' stamp: 'DaleHenrichs 3/6/2010 10:28'!
load

	self explicitLoadUsing: self loader! !

!MetacelloPackageSpec methodsFor: 'loading' stamp: 'DaleHenrichs 3/10/2010 12:32'!
loadUsing: mcLoader

	self loader doingLoads: [ self explicitLoadUsing: mcLoader ]! !

!MetacelloPackageSpec methodsFor: 'loading' stamp: 'DaleHenrichs 4/9/2010 12:29'!
loadUsing: aLoader gofer: gofer

	^aLoader linearLoadPackageSpec: self gofer: gofer! !

!MetacelloPackageSpec methodsFor: 'merging' stamp: 'DaleHenrichs 1/21/2010 20:37'!
mergeMap

	| map |
	map := super mergeMap.
	map at: #file put: file.
	map at: #repositories put: self repositories.
	map at: #preLoadDoIt put: preLoadDoIt.
	map at: #postLoadDoIt put: postLoadDoIt.
	^map! !

!MetacelloPackageSpec methodsFor: 'merging' stamp: 'Dalehenrichs 02/10/2010 10:54'!
mergeSpec: anotherSpec

	| newSpec map anotherPackages anotherRepositories |
	newSpec := super mergeSpec: anotherSpec.
	map := anotherSpec mergeMap.
	(anotherRepositories := map at: #repositories) notEmpty
		ifTrue: [ 
			newSpec 
				repositories: (self repositories isEmpty
					ifTrue: [ anotherRepositories ]
					ifFalse: [ self repositories mergeSpec: anotherRepositories ]) ].
	^newSpec! !

!MetacelloPackageSpec methodsFor: 'querying' stamp: 'dkh 06/03/2009 12:13'!
name

	name == nil ifTrue: [ name := self extractNameFromFile ].
	^name! !

!MetacelloPackageSpec methodsFor: 'merging' stamp: 'dkh 1/2/2010 16:29'!
nonOverridable

	^super nonOverridable, #( repositories)! !

!MetacelloPackageSpec methodsFor: 'querying' stamp: 'dkh 1/2/2010 15:35'!
packageRepository
	
	self repositorySpecs isEmpty ifTrue: [ ^nil ].
	^self repositorySpecs first! !

!MetacelloPackageSpec methodsFor: 'development support' stamp: 'dkh 12/22/2009 10:17'!
packagesNeedSavingVisited: visitedProjects using: repos into: aCollection

	^self loader packagesNeedSavingUsing: repos into: aCollection! !

!MetacelloPackageSpec methodsFor: 'loading' stamp: 'dkh 6/8/2009 16:16'!
packageSpecsInLoadOrder

	^{ self. }! !

!MetacelloPackageSpec methodsFor: 'copying' stamp: 'dkh 1/2/2010 15:46'!
postCopy

	super postCopy.
	goferPackage := nil.
	repositories := repositories copy.! !

!MetacelloPackageSpec methodsFor: 'querying' stamp: 'DaleHenrichs 1/21/2010 20:40'!
postLoadDoIt

	^postLoadDoIt! !

!MetacelloPackageSpec methodsFor: 'accessing' stamp: 'DaleHenrichs 1/21/2010 20:40'!
postLoadDoIt: aSymbol

	postLoadDoIt := aSymbol! !

!MetacelloPackageSpec methodsFor: 'querying' stamp: 'DaleHenrichs 1/21/2010 20:40'!
preLoadDoIt

	^preLoadDoIt! !

!MetacelloPackageSpec methodsFor: 'accessing' stamp: 'DaleHenrichs 1/21/2010 20:40'!
preLoadDoIt: aSymbol

	preLoadDoIt := aSymbol! !

!MetacelloPackageSpec methodsFor: 'visiting' stamp: 'dkh 10/5/2009 09:39'!
projectDo: projectBlock packageDo: packageBlock groupDo: groupBlock

	packageBlock value: self! !

!MetacelloPackageSpec methodsFor: 'querying' stamp: 'dkh 1/2/2010 15:41'!
repositories

	repositories == nil ifTrue: [ repositories := self project repositoriesSpec ].
	^ repositories! !

!MetacelloPackageSpec methodsFor: 'querying' stamp: 'dkh 1/2/2010 15:41'!
repositories: anObject
	repositories := anObject! !

!MetacelloPackageSpec methodsFor: 'querying' stamp: 'dkh 1/2/2010 15:46'!
repository

	self deprecated: 'Use repositories or repositorySpecs'.
	^self packageRepository! !

!MetacelloPackageSpec methodsFor: 'accessing' stamp: 'dkh 1/2/2010 15:44'!
repository: aStringOrMetacelloRepositorySpec

	self repositories repository: aStringOrMetacelloRepositorySpec! !

!MetacelloPackageSpec methodsFor: 'accessing' stamp: 'dkh 1/2/2010 15:47'!
repository: aString username: username password: password

	self repositories repository: aString username: username password: password! !

!MetacelloPackageSpec methodsFor: 'loading' stamp: 'dkh 1/2/2010 15:43'!
repositorySpecs

	^self repositories map values! !

!MetacelloPackageSpec methodsFor: 'private' stamp: 'dkh 10/21/2009 15:22'!
resolveToPackagesIn: aVersionSpec visited: visited

	^{ self }! !

!MetacelloPackageSpec methodsFor: 'development support' stamp: 'DaleHenrichs 3/15/2010 11:35'!
savePackage
	"Interactive save ... prompted for commit message and package name unless MCVersionNameAndMessageRequest handled"

	| latestFile pkgSpec |
	^(file notNil and: [ self name = self file ])
		ifTrue: [
			latestFile := self loader latestPackage: self name fromRepository: self repositorySpecs.
			pkgSpec := self copy.
			pkgSpec file: latestFile.
			pkgSpec savePackage ]
		ifFalse: [ self loader savePackageUsing: self repositorySpecs ]! !

!MetacelloPackageSpec methodsFor: 'development support' stamp: 'DaleHenrichs 1/21/2010 21:03'!
updateForSpawnMethod: sourceSpec

	| nm fl |
	nm := name.
	fl := file.
	sourceSpec ~~ nil ifTrue: [ fl := sourceSpec file ].
	super updateForSpawnMethod: sourceSpec.
	file := repositories := goferPackage := preLoadDoIt := postLoadDoIt := nil.
	name := nm.
	file := fl.! !

!MetacelloPackageSpec methodsFor: 'development support' stamp: 'dkh 01/14/2010 12:57'!
updatePackageRepositories: repositorySpecs

	| resolvedPackageRef |
	Transcript cr; show: '  Looking up version -> ', self file.
	resolvedPackageRef := self loader resolveSpec: self from: repositorySpecs.
	Transcript cr; show: 'Update repositoryGroup -> ', resolvedPackageRef name, ' ' , resolvedPackageRef repository description.
	resolvedPackageRef version workingCopy repositoryGroup addRepository: resolvedPackageRef repository! !

!MetacelloPackageSpec methodsFor: 'development support' stamp: 'dkh 11/01/2009 11:15'!
updatePackageRepositoriesFor: aVersionSpec
	"Don't update the repository unless the package is loaded in the image"
	
	self workingCopy == nil ifTrue: [ ^self ].
	self updatePackageRepositories: self repositorySpecs, aVersionSpec repositorySpecs.! !

!MetacelloPackageSpec methodsFor: 'development support' stamp: 'DaleHenrichs 03/12/2010 12:01'!
updatePackageSpec: updatedSpecs using: anMCLoader
	"Add pkg copy to updatedSpecs if the file in current image is different from the receiver's file"
	
	| viName |
	(viName := self workingCopyNameFor: anMCLoader) == nil 
		ifTrue: [ ^self ]. "no working copy"
	self getFile == nil ifTrue: [ ^self ]. "no file explicitly specified in this spec"
	(viName ~= self file)
		ifTrue: [ | spec |
			spec := self copy.
			spec file: viName.
			updatedSpecs at: spec name put: spec ]
		ifFalse: [ updatedSpecs at: self name put: #uptodate ].! !

!MetacelloPackageSpec methodsFor: 'visiting' stamp: 'dkh 10/21/2009 15:51'!
visitingWithPackages: packages

	packages at: self name put: self! !

!MetacelloPackageSpec methodsFor: 'gofer' stamp: 'dkh 9/25/2009 10:53'!
workingCopy

	^self goferPackage workingCopy! !

!MetacelloPackageSpec methodsFor: 'gofer' stamp: 'dkh 11/05/2009 13:58'!
workingCopyName

	| wc |
	(wc := self workingCopy) == nil ifTrue: [ ^nil ].
	wc ancestry ancestors isEmpty not
		ifTrue: [ ^wc ancestry ancestors first name ].
	^nil! !

!MetacelloPackageSpec methodsFor: 'gofer' stamp: 'dkh 9/25/2009 10:52'!
workingCopyNameFor: anMCLoader

	| vi |
	(vi := anMCLoader currentVersionInfoFor: self) == nil ifTrue: [ ^nil ].
	^vi name! !

MetacelloProject subclass: #MetacelloMCProject
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metacello-MC-Model'!

!MetacelloMCProject methodsFor: 'repository creation' stamp: 'dkh 10/22/2009 08:53'!
createRepository: aRepositorySpec

	^ MetacelloPlatform current createRepository: aRepositorySpec! !

!MetacelloMCProject methodsFor: 'spec classes' stamp: 'DaleHenrichs 3/6/2010 07:46'!
defaultLoaderClass

	^MetacelloLoadingMCSpecLoader! !

!MetacelloMCProject methodsFor: 'development support' stamp: 'DaleHenrichs 3/7/2010 09:51'!
fetchProject
	"fetch the latest version of the configuration package"
	
	^self fetchProject: MetacelloLoaderPolicy new! !

!MetacelloMCProject methodsFor: 'development support' stamp: 'DaleHenrichs 3/7/2010 09:49'!
fetchProject: aLoaderPolicy
	"fetch the latest version of the configuration package"
	
	| mcLoader |
	(mcLoader := self loader) == nil
		ifTrue: [ mcLoader := self project loaderClass on: nil ].
	mcLoader loaderPolicy: aLoaderPolicy.
	mcLoader doingLoads: [ 
		MCWorkingCopy
			managersForClass: self configuration class
			do: [:mgr | | pkg |
				pkg := self packageSpec.
				mgr repositoryGroup repositories do: [:repo | pkg repositories repository: (repo asRepositorySpecFor: self) ].
				pkg name: mgr packageName.
				pkg fetchUsing: mcLoader.
				^true ]].
	^true! !

!MetacelloMCProject methodsFor: 'development support' stamp: 'DaleHenrichs 3/15/2010 11:37'!
goferCommitProject: commitMessage

	| pkgSpec |
	(pkgSpec := self projectPackage) == nil ifTrue: [ ^false ].
	^pkgSpec goferCommitPackage: commitMessage! !

!MetacelloMCProject methodsFor: 'development support' stamp: 'dkh 12/22/2009 10:00'!
packagesNeedSaving: aVersionString
	"Answer a collection of associations (package -> repository) representing the packages 
	 reachable from this project that need to be saved"

	| packages |
	packages := Set new.
	(self version: aVersionString) spec 
		packagesNeedSavingVisited: (Set with: self configuration class name asString)
		into: packages.
	^packages! !

!MetacelloMCProject methodsFor: 'spec classes' stamp: 'dkh 06/01/2009 10:58'!
packageSpec

	^self packageSpecClass for: self! !

!MetacelloMCProject methodsFor: 'spec classes' stamp: 'dkh 06/01/2009 10:24'!
packageSpecClass

	^MetacelloPackageSpec! !

!MetacelloMCProject methodsFor: 'private' stamp: 'dkh 6/10/2009 10:56'!
pragmaKeywords

	^super pragmaKeywords, #(projectPackage:attribute: packages:attribute: repositories:attribute: )! !

!MetacelloMCProject methodsFor: 'development support' stamp: 'DaleHenrichs 03/20/2010 12:48'!
projectPackage

	MCWorkingCopy
		managersForClass: self configuration class
		do: [:mgr | | pkgSpec repo |
			pkgSpec := 
				self packageSpec
					name: mgr packageName;
					yourself.
			mgr ancestors notEmpty
				ifTrue: [ pkgSpec file: mgr ancestors first name ].
			repo := mgr repositoryGroup repositories 
				detect: [:each | each ~~ MCCacheRepository default ] 
				ifNone: [ 
					Transcript cr; show: 'Using cache repository for ', self label, ' project package'.
					MCCacheRepository default ].
			pkgSpec repository: repo description.
			^pkgSpec].
	^nil! !

!MetacelloMCProject methodsFor: 'spec classes' stamp: 'dkh 6/7/2009 10:11'!
repositoriesSpec

	^self repositoriesSpecClass for: self! !

!MetacelloMCProject methodsFor: 'spec classes' stamp: 'dkh 6/7/2009 10:11'!
repositoriesSpecClass

	^MetacelloRepositoriesSpec! !

!MetacelloMCProject methodsFor: 'spec classes' stamp: 'dkh 06/01/2009 10:59'!
repositorySpec

	^self repositorySpecClass for: self! !

!MetacelloMCProject methodsFor: 'spec classes' stamp: 'dkh 06/01/2009 10:25'!
repositorySpecClass

	^MetacelloRepositorySpec! !

!MetacelloMCProject methodsFor: 'development support' stamp: 'Dalehenrichs 02/10/2010 10:15'!
saveProject

	| pkgSpec |
	(pkgSpec := self projectPackage) == nil ifTrue: [ ^false ].
	^pkgSpec savePackage! !

!MetacelloMCProject methodsFor: 'repository updating' stamp: 'dkh 9/2/2009 06:21'!
updatePackageRepositoriesFor: versionString

	| versionSpec |
	(versionSpec := (self version: versionString) versionSpec) packageSpecsInLoadOrder do: [:pkgSpec |
		pkgSpec updatePackageRepositoriesFor: versionSpec ].
	^true! !

!MetacelloMCProject methodsFor: 'development support' stamp: 'DaleHenrichs 3/24/2010 15:50'!
updateProject
	"load the latest version of the configuration package"

	"WARNING: don't forget to refresh your project instance after doing an #updateProject, 
	 otherwise your instance won't reflect the info in the freshly loaded configuration"
	
	^self updateProject: MetacelloLoaderPolicy new! !

!MetacelloMCProject methodsFor: 'development support' stamp: 'DaleHenrichs 3/24/2010 15:50'!
updateProject: aLoaderPolicy
	"load the latest version of the configuration package"

	"WARNING: don't forget to refresh your project instance after doing an #updateProject, 
	 otherwise your instance won't reflect the info in the freshly loaded configuration"
	
	| mcLoader |
	(mcLoader := self loader) == nil
		ifTrue: [ mcLoader := self project loaderClass on: nil ].
	mcLoader loaderPolicy: aLoaderPolicy.
	mcLoader doingLoads: [ 
		MCWorkingCopy
			managersForClass: self configuration class
			do: [:mgr | | pkg |
				pkg := self packageSpec.
				mgr repositoryGroup repositories do: [:repo | pkg repositories repository: (repo asRepositorySpecFor: self) ].
				pkg name: mgr packageName.
				pkg load.
				^true ]].
	^true! !

!MetacelloMCProject methodsFor: 'spec classes' stamp: 'dkh 6/6/2009 12:19'!
versionSpecClass

	^MetacelloMCVersionSpec! !

!String methodsFor: '*metacello-mc' stamp: 'dkh 6/7/2009 10:15'!
addToMetacelloRepositories: aMetacelloRepositoriesSpec

	| spec |
	spec := 
		(aMetacelloRepositoriesSpec project repositorySpec)
			description: self;
			yourself.
	aMetacelloRepositoriesSpec addMember: 
		(aMetacelloRepositoriesSpec addMember 
			name: spec name;
			spec: spec;
			yourself)! !

!String methodsFor: '*metacello-mc' stamp: 'DaleHenrichs 3/7/2010 08:26'!
fetchRequiredForMetacelloMCVersion: aMetacelloMCVersion

	^aMetacelloMCVersion doFetchRequiredFromArray: (Array with: self).! !

!String methodsFor: '*metacello-mc' stamp: 'DaleHenrichs 3/7/2010 08:26'!
loadRequiredForMetacelloMCVersion: aMetacelloMCVersion

	^aMetacelloMCVersion doLoadRequiredFromArray: (Array with: self).! !

!String methodsFor: '*metacello-mc' stamp: 'dkh 6/7/2009 10:20'!
mergeIntoMetacelloRepositories: aMetacelloRepositoriesSpec

	| spec |
	spec := 
		(aMetacelloRepositoriesSpec project repositorySpec)
			description: self;
			yourself.
	aMetacelloRepositoriesSpec addMember: 
		(aMetacelloRepositoriesSpec mergeMember 
			name: spec name;
			spec: spec;
			yourself)! !

!String methodsFor: '*metacello-mc' stamp: 'dkh 9/23/2009 14:34'!
packageFileSpecFor: aMetacelloPackagesSpec

	^(aMetacelloPackagesSpec project packageSpec)
			file: self;
			yourself! !

!String methodsFor: '*metacello-mc' stamp: 'DaleHenrichs 3/11/2010 10:06'!
recordRequiredForMetacelloMCVersion: aMetacelloMCVersion

	^aMetacelloMCVersion doRecordRequiredFromArray: (Array with: self).! !

!String methodsFor: '*metacello-mc' stamp: 'dkh 6/7/2009 10:23'!
removeFromMetacelloRepositories: aMetacelloRepositoriesSpec

	aMetacelloRepositoriesSpec addMember: 
		(aMetacelloRepositoriesSpec removeMember 
			name: self;
			yourself)! !

!String methodsFor: '*metacello-mc' stamp: 'dkh 10/21/2009 19:18'!
resolvePackageSpecsNamedForMetacelloMCVersion: aMetacelloMCVersion visited: visited ifAbsent: aBlock 

	^ aMetacelloMCVersion 
		allPackagesForSpecs:  {aMetacelloMCVersion spec packageNamed: self ifAbsent: aBlock}
		visited: visited! !

MetacelloSpec subclass: #MetacelloRepositorySpec
	instanceVariableNames: 'description username password type'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metacello-MC-Specs'!

!MetacelloRepositorySpec methodsFor: 'adding' stamp: 'dkh 6/7/2009 10:13'!
addToMetacelloRepositories: aMetacelloRepositoriesSpec

	aMetacelloRepositoriesSpec addMember: 
		(aMetacelloRepositoriesSpec addMember 
			name: self name;
			spec: self;
			yourself)! !

!MetacelloRepositorySpec methodsFor: 'printing' stamp: 'dkh 10/22/2009 09:54'!
configMethodCascadeOn: aStream lastCascade: lastCascade

	aStream nextPutAll: 'repository: ', self description printString.
	(self username isEmpty not or: [ self password isEmpty not ])
		ifTrue: [ aStream nextPutAll: ' username: ', self username printString, ' password: ', self password printString ].
	lastCascade ifFalse: [ aStream nextPut: $;; cr ].! !

!MetacelloRepositorySpec methodsFor: 'printing' stamp: 'dkh 10/22/2009 09:54'!
configMethodOn: aStream indent: indent

	aStream 
		tab: indent; 
		nextPutAll: 'spec '.
	self configMethodCascadeOn: aStream lastCascade: true! !

!MetacelloRepositorySpec methodsFor: 'mc support' stamp: 'dkh 10/22/2009 08:52'!
createRepository

	^self project createRepository: self! !

!MetacelloRepositorySpec methodsFor: 'querying' stamp: 'dkh 06/03/2009 12:16'!
description

	^description! !

!MetacelloRepositorySpec methodsFor: 'accessing' stamp: 'dkh 06/03/2009 12:15'!
description: aString

	description := aString! !

!MetacelloRepositorySpec methodsFor: 'private' stamp: 'TestRunner 12/7/2009 14:30'!
extractTypeFromDescription

	^MetacelloPlatform current extractTypeFromDescription: self description! !

!MetacelloRepositorySpec methodsFor: 'private' stamp: 'dkh 6/7/2009 10:21'!
mergeIntoMetacelloRepositories: aMetacelloRepositoriesSpec

	aMetacelloRepositoriesSpec addMember: 
		(aMetacelloRepositoriesSpec mergeMember 
			name: self name;
			spec: self;
			yourself)! !

!MetacelloRepositorySpec methodsFor: 'merging' stamp: 'dkh 10/22/2009 09:11'!
mergeMap

	| map |
	map := super mergeMap.
	map at: #description put: description.
	map at: #type put: type.
	map at: #username put: username.
	map at: #password put: password.
	^map! !

!MetacelloRepositorySpec methodsFor: 'querying' stamp: 'dkh 6/7/2009 10:33'!
name

	^self description! !

!MetacelloRepositorySpec methodsFor: 'querying' stamp: 'dkh 10/22/2009 08:49'!
password

	password == nil ifTrue: [ password := '' ].
	^password! !

!MetacelloRepositorySpec methodsFor: 'accessing' stamp: 'dkh 10/22/2009 08:49'!
password: aString

	password := aString! !

!MetacelloRepositorySpec methodsFor: 'private' stamp: 'dkh 6/7/2009 10:24'!
removeFromMetacelloRepositories: aMetacelloRepositoriesSpec

	aMetacelloRepositoriesSpec addMember: 
		(aMetacelloRepositoriesSpec removeMember 
			name: self name;
			spec: self;
			yourself)! !

!MetacelloRepositorySpec methodsFor: 'querying' stamp: 'dkh 06/03/2009 12:16'!
type

	type == nil ifTrue: [ type := self extractTypeFromDescription ].
	^type! !

!MetacelloRepositorySpec methodsFor: 'accessing' stamp: 'dkh 06/03/2009 12:15'!
type: aString

	type := aString! !

!MetacelloRepositorySpec methodsFor: 'querying' stamp: 'dkh 10/22/2009 08:49'!
username

	username == nil ifTrue: [ username := '' ].
	^username! !

!MetacelloRepositorySpec methodsFor: 'accessing' stamp: 'dkh 10/22/2009 08:49'!
username: aString

	username := aString! !

!MetacelloProjectReferenceSpec methodsFor: '*metacello-mc' stamp: 'DaleHenrichs 3/5/2010 09:46'!
loadUsing: aLoader gofer: ignored

	| required |
	required := self resolveToLoadableSpec.
	required loader: aLoader.
	^required load! !

!MetacelloProjectReferenceSpec methodsFor: '*metacello-mc' stamp: 'DaleHenrichs 2/4/2010 13:49'!
packagesNeedSavingVisited: visitedProjects using: repos into: aCollection
	
	| prjct clsName vrsn |
	prjct := self resolveToLoadableSpec.
	(visitedProjects includes: (clsName := prjct className)) ifTrue: [ ^self ].
	visitedProjects add: clsName.
	(vrsn := self version) == nil ifTrue: [ ^self ].
	vrsn spec 
		packagesNeedSavingVisited: visitedProjects 
		into: aCollection! !

!MetacelloProjectReferenceSpec methodsFor: '*metacello-mc' stamp: 'dkh 10/3/2009 19:14'!
resolveProjectSpec

	^self projectReference! !

!MetacelloProjectReferenceSpec methodsFor: '*metacello-mc' stamp: 'dkh 10/21/2009 15:48'!
resolveToAllPackagesIn: aVersionSpec into: packages visited: visited

	(self resolveProjectSpec resolveToAllPackagesIn: aVersionSpec visited: visited) do: [:pkg |
		packages at: pkg put: pkg ]! !

!MetacelloProjectReferenceSpec methodsFor: '*metacello-mc' stamp: 'dkh 11/10/2009 09:48'!
resolveToLoadableSpec

	^self resolveProjectSpec resolveToLoadableSpec! !

!MetacelloProjectReferenceSpec methodsFor: '*metacello-mc' stamp: 'dkh 10/21/2009 15:22'!
resolveToPackagesIn: aVersionSpec visited: visited

	^#()! !

!MetacelloProjectReferenceSpec methodsFor: '*metacello-mc' stamp: 'dkh 11/21/2009 11:36'!
updateForSpawnMethod: sourceSpec

	| nm |
	nm := name.
	self projectReference updateForSpawnMethod: sourceSpec.
	super updateForSpawnMethod: sourceSpec.
	name := nm.! !

!MetacelloProjectReferenceSpec methodsFor: '*metacello-mc' stamp: 'dkh 10/23/2009 10:20'!
updatePackageSpec: updatedSpecs using: anMCLoader
	"Add project copy to updatedSpecs if the current version of the project 
	 is different from the receiver's version"
	
	self projectReference updatePackageSpec: updatedSpecs! !

!MetacelloProjectReferenceSpec methodsFor: '*metacello-mc' stamp: 'dkh 12/7/2009 16:24'!
versionString

	^self projectReference versionString! !

Object subclass: #MetacelloConfigTemplate
	instanceVariableNames: 'project'
	classVariableNames: 'LastVersionLoad'
	poolDictionaries: ''
	category: 'Metacello-MC-Model'!

!MetacelloConfigTemplate commentStamp: 'dkh 9/12/2009 09:02' prior: 0!
Copy me to start a new project!

!MetacelloConfigTemplate class methodsFor: 'private' stamp: 'dkh 10/11/2009 10:08'!
bootstrapPackage: aString from: aPath 
	| repository version |
	repository := MCHttpRepository
				location: aPath
				user: ''
				password: ''.
	repository
		versionReaderForFileNamed: aString , '.mcz'
		do: [:reader | 
			version := reader version.
			version load.
			version workingCopy repositoryGroup addRepository: repository]! !

!MetacelloConfigTemplate class methodsFor: 'private' stamp: 'DaleHenrichs 6/14/2010 12:53'!
ensureMetacello
	"Bootstrap Gofer (if necessary), load latest mcz file for ConfigurationOfMetacello (using old 
	 Gofer API), then load the latest version of Metacello itself."

	Smalltalk at: #MetacelloProject ifAbsent: [ | error |
		"list of repositories to try, in case primary repository is not accessible"
		(Array 
			with: 'http://www.squeaksource.com/MetacelloRepository' 
			with: 'http://seaside.gemstone.com/ss/metacello') do: [:repositoryUrl |
				([
					Smalltalk at: #Gofer ifAbsent: [
					"Current version of Gofer from which to bootstrap - as of 1.0-beta.21"
						self bootstrapPackage: 'Gofer-Core-lr.115' from: repositoryUrl ].
					Smalltalk at: #Gofer ifPresent: [:goferClass | | gofer |
						gofer := goferClass new
							url: repositoryUrl;
							yourself.
						[ gofer addPackage: 'ConfigurationOfMetacello' ] on: Warning do: [:ex | ex resume ].
						gofer load ]]
							on: Error
							do: [ :ex |
								error := ex.
								Transcript 
									cr; 
									show: 'failed ensureMetacello: ';
									show: ex description printString;
									show: '...retrying'.
								"try again"
								ex return: nil ]) ~~ nil
					ifTrue: [
						"load 'default' group of Metacello"
						(Smalltalk at: #ConfigurationOfMetacello) perform: #load.
						^self ]].
		"shouldn't get here unless the load failed ... throw an error"
		self error: 'retry with alternate repository failed: ', error description printString ]! !

!MetacelloConfigTemplate class methodsFor: 'metacello tool support' stamp: 'dkh 10/7/2009 14:52'!
isMetacelloConfig
	"Answer true and the Metacello tools will operate on you"
	
	^true! !

!MetacelloConfigTemplate class methodsFor: 'metacello tool support' stamp: 'dkh 11/03/2009 11:04'!
lastMetacelloVersionLoad
	"Answer the last version loaded and the list of packages loaded for that version."

	LastVersionLoad == nil ifTrue: [ LastVersionLoad := nil -> 'default' ].
	^LastVersionLoad! !

!MetacelloConfigTemplate class methodsFor: 'loading' stamp: 'SeanDeNigris 8/17/2010 16:13'!
load
	"self load"

	^self project stableVersion load! !

!MetacelloConfigTemplate class methodsFor: 'metacello tool support' stamp: 'dkh 11/3/2009 10:12'!
metacelloVersion: versionString loads: anArrayOrString
	"Stash the last version loaded and the list of packages loaded for that version. The list
	 of packages will be used by the tools when doing 'Load Package Version'"

	LastVersionLoad := versionString -> anArrayOrString! !

!MetacelloConfigTemplate class methodsFor: 'accessing' stamp: 'dkh 10/13/2009 10:36'!
project

	^self new project! !

!MetacelloConfigTemplate class methodsFor: 'unloading Metacello' stamp: 'DaleHenrichs 1/27/2010 11:57'!
unloadMetacello

	Smalltalk at: #ConfigurationOfMetacello ifPresent: [:cls | cls unloadMetacello ]! !

!MetacelloConfigTemplate methodsFor: 'accessing' stamp: 'dkh 12/10/2009 11:55'!
project

	^ project ifNil: [ | constructor |
		"Bootstrap Metacello if it is not already loaded"
		self class ensureMetacello.
		"Construct Metacello project"
		constructor := (Smalltalk at: #MetacelloVersionConstructor) on: self.
		project := constructor project.
		project loadType: #linear. "change to #atomic if desired"
		project ]! !

Object subclass: #MetacelloDirective
	instanceVariableNames: 'spec loader'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metacello-MC-Directives'!

!MetacelloDirective class methodsFor: 'instance creation' stamp: 'DaleHenrichs 3/9/2010 12:19'!
loader: aLoader

	^self new
		loader: aLoader! !

!MetacelloDirective class methodsFor: 'instance creation' stamp: 'DaleHenrichs 3/9/2010 16:42'!
loadPackage: aPackageSpec externalReference: externalReference loader: aLoader

	^MetacelloPackageLoadDirective new
		spec: aPackageSpec externalReference: externalReference  loader: aLoader! !

!MetacelloDirective class methodsFor: 'instance creation' stamp: 'DaleHenrichs 3/9/2010 10:48'!
postLoadSpec: packageOrVersionSpec loader: aLoader

	^MetacelloPostLoadDirective new
		spec: packageOrVersionSpec loader: aLoader! !

!MetacelloDirective class methodsFor: 'instance creation' stamp: 'DaleHenrichs 3/9/2010 10:48'!
preLoadSpec: packageOrVersionSpec loader: aLoader

	^MetacelloPreLoadDirective new
		spec: packageOrVersionSpec loader: aLoader! !

!MetacelloDirective methodsFor: 'actions' stamp: 'DaleHenrichs 3/9/2010 12:11'!
addTo: aLoaderDirective

	aLoaderDirective add: self! !

!MetacelloDirective methodsFor: 'enumerating' stamp: 'DaleHenrichs 3/10/2010 15:48'!
directivesDo: aBlock

	aBlock value: self! !

!MetacelloDirective methodsFor: 'printing' stamp: 'DaleHenrichs 3/9/2010 16:36'!
label

	^self spec label! !

!MetacelloDirective methodsFor: 'accessing' stamp: 'DaleHenrichs 3/9/2010 10:44'!
loader

	^loader! !

!MetacelloDirective methodsFor: 'accessing' stamp: 'DaleHenrichs 3/9/2010 12:19'!
loader: aLoader

	loader := aLoader! !

!MetacelloDirective methodsFor: 'actions' stamp: 'DaleHenrichs 3/9/2010 14:53'!
loadUsing: aLoaderDirective gofer: aGofer

	self subclassResponsibility! !

!MetacelloDirective methodsFor: 'enumerating' stamp: 'DaleHenrichs 3/11/2010 13:40'!
packageDirectivesDo: aBlock! !

!MetacelloDirective methodsFor: 'actions' stamp: 'DaleHenrichs 3/11/2010 13:49'!
packageDo: aBlock! !

!MetacelloDirective methodsFor: 'actions' stamp: 'DaleHenrichs 4/8/2010 16:31'!
postLoadDo: aBlock! !

!MetacelloDirective methodsFor: 'actions' stamp: 'DaleHenrichs 4/8/2010 16:31'!
preLoadDo: aBlock! !

!MetacelloDirective methodsFor: 'enumerating' stamp: 'DaleHenrichs 4/7/2010 12:25'!
prepostLoadDirectivesDo: aBlock! !

!MetacelloDirective methodsFor: 'enumerating' stamp: 'DaleHenrichs 4/7/2010 12:26'!
prepostLoadDo: aBlock! !

!MetacelloDirective methodsFor: 'printing' stamp: 'DaleHenrichs 3/9/2010 11:53'!
printOn: aStream

	self printOn: aStream indent: 0! !

!MetacelloDirective methodsFor: 'printing' stamp: 'DaleHenrichs 3/9/2010 16:35'!
printOn: aStream indent: indent

	indent timesRepeat: [ aStream tab ].
	aStream
		nextPutAll: self title;
		nextPutAll: ' : ';
		nextPutAll: self label.! !

!MetacelloDirective methodsFor: 'accessing' stamp: 'DaleHenrichs 3/10/2010 11:06'!
spec

	^spec! !

!MetacelloDirective methodsFor: 'initialize-release' stamp: 'DaleHenrichs 3/9/2010 10:46'!
spec: packageOrVersionSpec loader: aLoader

	spec := packageOrVersionSpec.
	loader := aLoader! !

!MetacelloDirective methodsFor: 'accessing' stamp: 'DaleHenrichs 3/9/2010 16:35'!
title

	self subclassResponsibility! !

!MetacelloDirective methodsFor: 'enumerating' stamp: 'DaleHenrichs 3/12/2010 10:27'!
versionDirectivesDo: aBlock! !

!MetacelloDirective methodsFor: 'actions' stamp: 'DaleHenrichs 4/7/2010 12:32'!
versionDo: aBlock! !

MetacelloDirective subclass: #MetacelloPackageLoadDirective
	instanceVariableNames: 'resolvedReference externalReference'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metacello-MC-Directives'!

!MetacelloPackageLoadDirective methodsFor: 'accessing' stamp: 'DaleHenrichs 3/9/2010 16:42'!
externalReference
	^ externalReference! !

!MetacelloPackageLoadDirective methodsFor: 'accessing' stamp: 'DaleHenrichs 3/9/2010 16:39'!
file

	^self externalReference name! !

!MetacelloPackageLoadDirective methodsFor: 'printing' stamp: 'DaleHenrichs 3/9/2010 16:36'!
label

	^self file! !

!MetacelloPackageLoadDirective methodsFor: 'actions' stamp: 'DaleHenrichs 3/9/2010 14:58'!
loadUsing: aLoaderDirective gofer: aGofer

	aLoaderDirective loadPackageDirective: self gofer: aGofer! !

!MetacelloPackageLoadDirective methodsFor: 'enumerating' stamp: 'DaleHenrichs 3/11/2010 21:09'!
packageDirectivesDo: aBlock

	aBlock value: self! !

!MetacelloPackageLoadDirective methodsFor: 'enumerating' stamp: 'DaleHenrichs 3/11/2010 13:55'!
packageDo: aBlock

	aBlock value: self! !

!MetacelloPackageLoadDirective methodsFor: 'accessing' stamp: 'DaleHenrichs 3/12/2010 09:29'!
packageName

	^self externalReference packageName! !

!MetacelloPackageLoadDirective methodsFor: 'accessing' stamp: 'DaleHenrichs 3/9/2010 16:39'!
repository

	^self externalReference repository! !

!MetacelloPackageLoadDirective methodsFor: 'accessing' stamp: 'DaleHenrichs 3/9/2010 15:24'!
resolvedReference
	^ resolvedReference! !

!MetacelloPackageLoadDirective methodsFor: 'accessing' stamp: 'DaleHenrichs 3/9/2010 15:24'!
resolvedReference: anObject
	resolvedReference := anObject! !

!MetacelloPackageLoadDirective methodsFor: 'initialize-release' stamp: 'DaleHenrichs 3/9/2010 16:41'!
spec: aPackageSpec externalReference: anExternalReference loader: aLoader

	super spec: aPackageSpec loader: aLoader.
	externalReference := anExternalReference! !

!MetacelloPackageLoadDirective methodsFor: 'accessing' stamp: 'DaleHenrichs 3/9/2010 16:35'!
title

	^'load'! !

MetacelloDirective subclass: #MetacelloPrePostLoadDirective
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metacello-MC-Directives'!

MetacelloPrePostLoadDirective subclass: #MetacelloPostLoadDirective
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metacello-MC-Directives'!

!MetacelloPostLoadDirective methodsFor: 'actions' stamp: 'DaleHenrichs 4/14/2010 15:19'!
addTo: aLoaderDirective

	spec postLoadDoIt ~~ nil ifTrue: [ aLoaderDirective add: self ]! !

!MetacelloPostLoadDirective methodsFor: 'printing' stamp: 'DaleHenrichs 4/14/2010 15:28'!
label

	^super label, ' >> ', self spec postLoadDoIt asString! !

!MetacelloPostLoadDirective methodsFor: 'actions' stamp: 'DaleHenrichs 4/14/2010 14:30'!
loadUsing: aLoaderDirective gofer: aGofer

	aLoaderDirective loadPostloadDirective: self.! !

!MetacelloPostLoadDirective methodsFor: 'actions' stamp: 'DaleHenrichs 4/8/2010 16:15'!
postLoadDo: aBlock

	aBlock value: self! !

!MetacelloPostLoadDirective methodsFor: 'accessing' stamp: 'DaleHenrichs 3/9/2010 16:35'!
title

	^'postload'! !

MetacelloPrePostLoadDirective subclass: #MetacelloPreLoadDirective
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metacello-MC-Directives'!

!MetacelloPreLoadDirective methodsFor: 'actions' stamp: 'DaleHenrichs 4/14/2010 15:19'!
addTo: aLoaderDirective

	spec preLoadDoIt ~~ nil ifTrue: [ aLoaderDirective add: self ]! !

!MetacelloPreLoadDirective methodsFor: 'printing' stamp: 'DaleHenrichs 4/14/2010 15:28'!
label

	^super label, ' >> ', self spec preLoadDoIt asString! !

!MetacelloPreLoadDirective methodsFor: 'actions' stamp: 'DaleHenrichs 4/14/2010 14:30'!
loadUsing: aLoaderDirective gofer: aGofer

	aLoaderDirective loadPreloadDirective: self.! !

!MetacelloPreLoadDirective methodsFor: 'actions' stamp: 'DaleHenrichs 4/8/2010 16:16'!
preLoadDo: aBlock

	aBlock value: self! !

!MetacelloPreLoadDirective methodsFor: 'accessing' stamp: 'DaleHenrichs 3/9/2010 16:35'!
title

	^'preload'! !

!MetacelloPrePostLoadDirective methodsFor: 'actions' stamp: 'DaleHenrichs 4/9/2010 12:45'!
evaluateSupplyingAnswers: loadBlock

	| answers |
	(answers := self spec answers) notEmpty
		ifTrue: [ loadBlock valueSupplyingMetacelloAnswers: answers ]
		ifFalse: [ loadBlock value]! !

!MetacelloPrePostLoadDirective methodsFor: 'enumerating' stamp: 'DaleHenrichs 4/8/2010 16:22'!
prepostLoadDirectivesDo: aBlock

	aBlock value: self! !

!MetacelloPrePostLoadDirective methodsFor: 'enumerating' stamp: 'DaleHenrichs 4/8/2010 16:23'!
prepostLoadDo: aBlock

	aBlock value: self! !

MetacelloDirective subclass: #MetacelloVersionLoadDirective
	instanceVariableNames: 'loadDirectives'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metacello-MC-Directives'!

MetacelloVersionLoadDirective subclass: #MetacelloAtomicLoadDirective
	instanceVariableNames: 'packageloads preloads postloads'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metacello-MC-Directives'!

!MetacelloAtomicLoadDirective methodsFor: 'enumerating' stamp: 'DaleHenrichs 4/9/2010 13:01'!
directivesDo: aBlock

	aBlock value: self.
	self preloads do: [:directive | directive directivesDo: aBlock ].
	self loadDirectives do: [:directive | directive directivesDo: aBlock ].
	self postloads do: [:directive | directive directivesDo: aBlock ].! !

!MetacelloAtomicLoadDirective methodsFor: 'actions' stamp: 'DaleHenrichs 4/14/2010 14:28'!
finalizeLoad: aGofer
	"load the accumulated packages (if any), reset the package list"

	| pkgLoads |
	self preloads do: [:directive | super loadPreloadDirective: directive ].
	preloads := nil.
	(pkgLoads := self packageloads) notEmpty 
		ifTrue: [
			self loader loadingSpecLoader 
				loadPackageDirectives: pkgLoads 
				gofer: aGofer.
			self packageloads: nil ].
	self postloads do: [:directive | super loadPostloadDirective: directive ].
	postloads := nil! !

!MetacelloAtomicLoadDirective methodsFor: 'actions' stamp: 'DaleHenrichs 3/21/2010 16:20'!
loadAtomicLoadDirective: aLoaderDirective gofer: aGofer

	aLoaderDirective loadDirectives do: [:directive | directive loadUsing: self gofer: aGofer ].! !

!MetacelloAtomicLoadDirective methodsFor: 'actions' stamp: 'DaleHenrichs 4/13/2010 17:27'!
loadLinearLoadDirective: aLoaderDirective gofer: aGofer

	self finalizeLoad: aGofer.
	super loadLinearLoadDirective: aLoaderDirective gofer: aGofer! !

!MetacelloAtomicLoadDirective methodsFor: 'loading' stamp: 'DaleHenrichs 3/16/2010 01:53'!
loadPackageDirective: aPackageLoadDirective gofer: aGofer
	"accumulate packages"
	
	self packageloads add: aPackageLoadDirective! !

!MetacelloAtomicLoadDirective methodsFor: 'loading' stamp: 'DaleHenrichs 4/14/2010 14:23'!
loadPostloadDirective: aPostloadDirective
	"accumulate postloads"

	self postloads add: aPostloadDirective! !

!MetacelloAtomicLoadDirective methodsFor: 'loading' stamp: 'DaleHenrichs 4/14/2010 14:23'!
loadPreloadDirective: aPreloadDirective 
	"accumulate preloads"

	self preloads add: aPreloadDirective! !

!MetacelloAtomicLoadDirective methodsFor: 'actions' stamp: 'DaleHenrichs 4/14/2010 14:21'!
loadUsing: aLoaderDirective gofer: aGofer

	self loadDirectives isEmpty ifTrue: [ ^self ].
	aLoaderDirective loadAtomicLoadDirective: self gofer: aGofer.! !

!MetacelloAtomicLoadDirective methodsFor: 'accessing' stamp: 'DaleHenrichs 3/9/2010 15:05'!
packageloads

	packageloads == nil ifTrue: [ packageloads := OrderedCollection new ].
	^ packageloads! !

!MetacelloAtomicLoadDirective methodsFor: 'accessing' stamp: 'DaleHenrichs 3/9/2010 15:04'!
packageloads: anObject
	packageloads := anObject! !

!MetacelloAtomicLoadDirective methodsFor: 'accessing' stamp: 'DaleHenrichs 4/9/2010 13:00'!
postloads

	postloads == nil ifTrue: [ postloads := OrderedCollection new ].
	^ postloads! !

!MetacelloAtomicLoadDirective methodsFor: 'accessing' stamp: 'DaleHenrichs 4/9/2010 13:00'!
preloads

	preloads == nil ifTrue: [ preloads := OrderedCollection new ].
	^ preloads! !

!MetacelloAtomicLoadDirective methodsFor: 'enumerating' stamp: 'DaleHenrichs 4/9/2010 13:03'!
prepostLoadDirectivesDo: aBlock

	self preloads do: [:directive | directive prepostLoadDirectivesDo: aBlock ].
	self loadDirectives do: [:directive | directive prepostLoadDirectivesDo: aBlock ].
	self postloads do: [:directive | directive prepostLoadDirectivesDo: aBlock ].! !

!MetacelloAtomicLoadDirective methodsFor: 'enumerating' stamp: 'DaleHenrichs 4/9/2010 13:03'!
prepostLoadsDo: aBlock

	self preloads do: [:directive | directive prepostLoadDo: aBlock ].
	self loadDirectives do: [:directive | directive prepostLoadDo: aBlock ].
	self postloads do: [:directive | directive prepostLoadDo: aBlock ].! !

!MetacelloAtomicLoadDirective methodsFor: 'accessing' stamp: 'DaleHenrichs 3/9/2010 16:35'!
title

	^'atomic load'! !

MetacelloVersionLoadDirective subclass: #MetacelloExplicitLoadDirective
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metacello-MC-Directives'!

!MetacelloExplicitLoadDirective methodsFor: 'actions' stamp: 'DaleHenrichs 3/21/2010 13:39'!
explicitLoadUsing: aLoaderDirective gofer: aGofer

	aLoaderDirective loadLinearLoadDirective: self gofer: aGofer.! !

!MetacelloExplicitLoadDirective methodsFor: 'actions' stamp: 'DaleHenrichs 3/21/2010 13:16'!
explicitLoadWithPolicy: aLoadPolicy

	| gofer |
	gofer := Gofer new.
	gofer disablePackageCache.
	gofer repository: aLoadPolicy cacheRepository.
	self explicitLoadUsing: self gofer: gofer! !

!MetacelloExplicitLoadDirective methodsFor: 'actions' stamp: 'DaleHenrichs 3/21/2010 13:38'!
loadUsing: aLoaderDirective gofer: aGofer

	aLoaderDirective loadExplicitLoadDirective: self gofer: aGofer.! !

!MetacelloExplicitLoadDirective methodsFor: 'accessing' stamp: 'DaleHenrichs 3/18/2010 11:46'!
title

	^'explicit load'! !

MetacelloVersionLoadDirective subclass: #MetacelloLinearLoadDirective
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metacello-MC-Directives'!

!MetacelloLinearLoadDirective methodsFor: 'actions' stamp: 'DaleHenrichs 3/21/2010 13:40'!
loadUsing: aLoaderDirective gofer: aGofer

	self loadDirectives isEmpty ifTrue: [ ^self ].
	aLoaderDirective loadLinearLoadDirective: self gofer: aGofer.! !

!MetacelloLinearLoadDirective methodsFor: 'accessing' stamp: 'DaleHenrichs 3/9/2010 16:35'!
title

	^'linear load'! !

!MetacelloVersionLoadDirective methodsFor: 'actions' stamp: 'DaleHenrichs 3/9/2010 12:14'!
add: aDirective

	self loadDirectives add: aDirective! !

!MetacelloVersionLoadDirective methodsFor: 'enumerating' stamp: 'DaleHenrichs 4/7/2010 12:16'!
directivesDo: aBlock

	aBlock value: self.
	self loadDirectives do: [:directive | directive directivesDo: aBlock ].! !

!MetacelloVersionLoadDirective methodsFor: 'actions' stamp: 'DaleHenrichs 3/16/2010 02:08'!
finalizeLoad: aGofer
	"nothing special for linear loads"! !

!MetacelloVersionLoadDirective methodsFor: 'printing' stamp: 'DaleHenrichs 3/10/2010 11:07'!
label

	self spec == nil ifTrue: [ ^'' ].
	^self spec label! !

!MetacelloVersionLoadDirective methodsFor: 'actions' stamp: 'DaleHenrichs 3/21/2010 13:37'!
loadAtomicLoadDirective: aLoaderDirective gofer: aGofer

	aLoaderDirective loadDirectives do: [:directive | directive loadUsing: aLoaderDirective gofer: aGofer ].
	aLoaderDirective finalizeLoad: aGofer.! !

!MetacelloVersionLoadDirective methodsFor: 'accessing' stamp: 'DaleHenrichs 3/9/2010 12:13'!
loadDirectives

	loadDirectives == nil ifTrue: [ loadDirectives := OrderedCollection new ].
	^ loadDirectives! !

!MetacelloVersionLoadDirective methodsFor: 'accessing' stamp: 'DaleHenrichs 3/9/2010 12:13'!
loadDirectives: anObject
	loadDirectives := anObject! !

!MetacelloVersionLoadDirective methodsFor: 'actions' stamp: 'DaleHenrichs 3/21/2010 13:38'!
loadExplicitLoadDirective: aLoaderDirective gofer: aGofer
	"load has already been performed, no need to load again"! !

!MetacelloVersionLoadDirective methodsFor: 'actions' stamp: 'DaleHenrichs 3/21/2010 13:39'!
loadLinearLoadDirective: aLoaderDirective gofer: aGofer

	aLoaderDirective loadDirectives do: [:directive | directive loadUsing: aLoaderDirective gofer: aGofer ].
	aLoaderDirective finalizeLoad: aGofer.! !

!MetacelloVersionLoadDirective methodsFor: 'loading' stamp: 'DaleHenrichs 4/9/2010 12:08'!
loadPackageDirective: aPackageLoadDirective gofer: aGofer

	aPackageLoadDirective loader loadingSpecLoader 
		loadPackageDirective: aPackageLoadDirective 
		gofer: aGofer! !

!MetacelloVersionLoadDirective methodsFor: 'loading' stamp: 'DaleHenrichs 4/14/2010 14:30'!
loadPostloadDirective: aPostloadDirective 

	| block |
	(block :=  aPostloadDirective spec postLoadDoItBlock) ~~ nil
		ifTrue: [
			aPostloadDirective evaluateSupplyingAnswers: [ block valueWithPossibleArgs: 
					(Array 
						with: aPostloadDirective loader 
						with: aPostloadDirective spec) ].
			Transcript cr; show: 'Evaluated -> ', aPostloadDirective spec label, ' >> ', aPostloadDirective spec postLoadDoIt asString]! !

!MetacelloVersionLoadDirective methodsFor: 'loading' stamp: 'DaleHenrichs 4/14/2010 14:31'!
loadPreloadDirective: aPreloadDirective 

	| block |
	(block :=  aPreloadDirective spec preLoadDoItBlock) ~~ nil
		ifTrue: [
			aPreloadDirective evaluateSupplyingAnswers: [ block valueWithPossibleArgs: 
					(Array 
						with: aPreloadDirective loader 
						with: aPreloadDirective spec) ].
			Transcript cr; show: 'Evaluated -> ', aPreloadDirective spec label, ' >> ', aPreloadDirective spec preLoadDoIt asString]! !

!MetacelloVersionLoadDirective methodsFor: 'actions' stamp: 'DaleHenrichs 3/9/2010 16:37'!
loadWithPolicy: aLoadPolicy

	| gofer |
	gofer := Gofer new.
	gofer disablePackageCache.
	gofer repository: aLoadPolicy cacheRepository.
	self loadUsing: self gofer: gofer! !

!MetacelloVersionLoadDirective methodsFor: 'enumerating' stamp: 'DaleHenrichs 3/11/2010 13:40'!
packageDirectivesDo: aBlock

	self loadDirectives do: [:directive | directive packageDirectivesDo: aBlock ].! !

!MetacelloVersionLoadDirective methodsFor: 'enumerating' stamp: 'DaleHenrichs 3/11/2010 13:49'!
packagesDo: aBlock

	self loadDirectives do: [:directive | directive packageDo: aBlock ].! !

!MetacelloVersionLoadDirective methodsFor: 'enumerating' stamp: 'DaleHenrichs 4/7/2010 12:26'!
prepostLoadDirectivesDo: aBlock

	self loadDirectives do: [:directive | directive prepostLoadDirectivesDo: aBlock ].! !

!MetacelloVersionLoadDirective methodsFor: 'enumerating' stamp: 'DaleHenrichs 4/7/2010 12:28'!
prepostLoadsDo: aBlock

	self loadDirectives do: [:directive | directive prepostLoadDo: aBlock ].! !

!MetacelloVersionLoadDirective methodsFor: 'printing' stamp: 'DaleHenrichs 4/9/2010 13:04'!
printLoadDirectivesOn: aStream indent: indent

	self loadDirectives do: [:each |
		aStream cr. 
		each printOn: aStream indent: indent + 1 ].! !

!MetacelloVersionLoadDirective methodsFor: 'printing' stamp: 'DaleHenrichs 4/9/2010 13:04'!
printOn: aStream indent: indent

	super printOn: aStream indent: indent.
	self printLoadDirectivesOn: aStream indent: indent! !

!MetacelloVersionLoadDirective methodsFor: 'accessing' stamp: 'DaleHenrichs 3/12/2010 09:19'!
spec
	"Expected to be a MetacelloVersionSpec"
	
	(spec == nil  and: [  self loader ~~ nil ]) ifTrue: [ ^self loader spec versionSpec ].
	^spec! !

!MetacelloVersionLoadDirective methodsFor: 'enumerating' stamp: 'DaleHenrichs 3/12/2010 10:27'!
versionDirectivesDo: aBlock

	aBlock value: self.
	self loadDirectives do: [:directive | directive versionDirectivesDo: aBlock ].! !

!MetacelloVersionLoadDirective methodsFor: 'enumerating' stamp: 'DaleHenrichs 4/7/2010 12:32'!
versionDo: aBlock

	aBlock value: self.! !

!MetacelloVersionLoadDirective methodsFor: 'enumerating' stamp: 'DaleHenrichs 4/7/2010 12:32'!
versionsDo: aBlock

	self loadDirectives do: [:directive | directive versionDo: aBlock ].! !

Object subclass: #MetacelloLoadData
	instanceVariableNames: 'dataMap versionInfoMap packageNameMap'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metacello-MC-Loaders'!

!MetacelloLoadData methodsFor: 'accessing' stamp: 'dkh 1/12/2010 16:32'!
addVersion: version versionInfo: versionInfo resolvedReference: resolvedReference packageSpec: packageSpec

	| vi |
	"check for duplicates and use the one that is being added"
	(vi := self packageNameMap at: packageSpec name ifAbsent: []) ~~ nil
		ifTrue: [	
			"remove old references"			
			self dataMap removeKey: vi name.			
			self versionInfoMap removeKey: vi name].
	self dataMap at: version info name put: {version. resolvedReference. packageSpec }.
	self versionInfoMap at: versionInfo name put: versionInfo.
	self packageNameMap
		at: packageSpec name
		put: versionInfo! !

!MetacelloLoadData methodsFor: 'versionInfo' stamp: 'dkh 08/10/2009 16:37'!
currentVersionInfoFor: packageSpec ifAbsent: aBlock

	^self versionInfoMap 
		at: packageSpec file 
		ifAbsent: [ 
			self  packageNameMap 
				at: packageSpec name
				ifAbsent: aBlock ]! !

!MetacelloLoadData methodsFor: 'accessing' stamp: 'dkh 07/08/2009 12:34'!
dataMap

	dataMap == nil ifTrue: [ dataMap := Dictionary new ].
	^dataMap! !

!MetacelloLoadData methodsFor: 'enumerating' stamp: 'dkh 7/29/2009 19:53'!
do: aBlock

	self dataMap valuesDo: [:ar |
		aBlock value: (ar at: 1) value: (ar at: 2) value: (ar at: 3) ]! !

!MetacelloLoadData methodsFor: 'testing' stamp: 'dkh 07/08/2009 12:38'!
isEmpty

	^self dataMap isEmpty! !

!MetacelloLoadData methodsFor: 'accessing' stamp: 'dkh 08/10/2009 16:17'!
packageNameMap

	packageNameMap == nil ifTrue: [ packageNameMap := Dictionary new ].
	^packageNameMap! !

!MetacelloLoadData methodsFor: 'accessing' stamp: 'dkh 07/08/2009 12:48'!
versionInfoMap

	versionInfoMap == nil ifTrue: [ versionInfoMap := Dictionary new ].
	^versionInfoMap! !

Object subclass: #MetacelloLoaderPolicy
	instanceVariableNames: 'overrideRepositories repositoryMap ensuredMap cacheRepository cacheGofer ignoreImage loadData loadDirective silently'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metacello-MC-Loaders'!

!MetacelloLoaderPolicy class methodsFor: 'instance creation' stamp: 'DaleHenrichs 3/7/2010 08:10'!
overrideRepositories: aCollection

	^self new overrideRepositories: aCollection! !

!MetacelloLoaderPolicy methodsFor: 'accessing' stamp: 'DaleHenrichs 03/08/2010 16:20'!
cacheGofer

	cacheGofer == nil 
		ifTrue: [ 
			cacheGofer := Gofer new.
			cacheGofer disablePackageCache.
			cacheGofer repository: self cacheRepository. ].
	^ cacheGofer! !

!MetacelloLoaderPolicy methodsFor: 'accessing' stamp: 'DaleHenrichs 3/7/2010 08:34'!
cacheRepository

	cacheRepository == nil ifTrue: [ cacheRepository := MCDictionaryRepository new ].
	^ cacheRepository! !

!MetacelloLoaderPolicy methodsFor: 'accessing' stamp: 'DaleHenrichs 3/7/2010 08:34'!
cacheRepository: anMCRepository

	cacheRepository := anMCRepository! !

!MetacelloLoaderPolicy methodsFor: 'accessing' stamp: 'DaleHenrichs 03/08/2010 14:47'!
ensuredMap

	ensuredMap == nil ifTrue: [ ensuredMap := Dictionary new ].
	^ensuredMap! !

!MetacelloLoaderPolicy methodsFor: 'accessing' stamp: 'DaleHenrichs 03/08/2010 14:47'!
ensuredMap: anObject
	ensuredMap := anObject! !

!MetacelloLoaderPolicy methodsFor: 'testing' stamp: 'DaleHenrichs 3/7/2010 08:14'!
hasRepositoryOverrides

	^self overrideRepositories ~~ nil! !

!MetacelloLoaderPolicy methodsFor: 'accessing' stamp: 'DaleHenrichs 3/8/2010 11:39'!
ignoreImage
	^ ignoreImage! !

!MetacelloLoaderPolicy methodsFor: 'accessing' stamp: 'DaleHenrichs 3/8/2010 11:39'!
ignoreImage: anObject
	ignoreImage := anObject! !

!MetacelloLoaderPolicy methodsFor: 'initialize-release' stamp: 'DaleHenrichs 03/08/2010 14:47'!
initialize

	self 
		repositoryMap; 
		cacheRepository;
		ensuredMap.
	ignoreImage := false! !

!MetacelloLoaderPolicy methodsFor: 'actions' stamp: 'DaleHenrichs 3/10/2010 10:02'!
load

	overrideRepositories := Array with: self cacheRepository. "ensure that hasRepositoryOverrides is true"
	self loadDirective loadWithPolicy: self! !

!MetacelloLoaderPolicy methodsFor: 'accessing' stamp: 'DaleHenrichs 3/11/2010 12:59'!
loadData

 	loadData == nil ifTrue: [ loadData := MetacelloLoadData new ].
	^loadData! !

!MetacelloLoaderPolicy methodsFor: 'accessing' stamp: 'DaleHenrichs 3/10/2010 11:11'!
loadDirective

	loadDirective == nil ifTrue: [ loadDirective := MetacelloLinearLoadDirective new ].
	^ loadDirective! !

!MetacelloLoaderPolicy methodsFor: 'accessing' stamp: 'DaleHenrichs 3/7/2010 08:09'!
overrideRepositories
	^ overrideRepositories! !

!MetacelloLoaderPolicy methodsFor: 'accessing' stamp: 'DaleHenrichs 3/7/2010 08:09'!
overrideRepositories: anObject
	overrideRepositories := anObject! !

!MetacelloLoaderPolicy methodsFor: 'actions' stamp: 'DaleHenrichs 3/9/2010 16:50'!
pushAtomicLoadDirectivesDuring: aBlock for: aLoader

	self pushLoadDirective: (MetacelloAtomicLoadDirective loader: aLoader) during: aBlock.! !

!MetacelloLoaderPolicy methodsFor: 'actions' stamp: 'DaleHenrichs 3/21/2010 13:11'!
pushExplicitLoadDirectivesDuring: aBlock for: aLoader

	| directive |
	directive := MetacelloExplicitLoadDirective loader: aLoader.
	self pushLoadDirective: directive during: aBlock.
	^directive! !

!MetacelloLoaderPolicy methodsFor: 'actions' stamp: 'DaleHenrichs 3/9/2010 16:50'!
pushLinearLoadDirectivesDuring: aBlock for: aLoader

	self pushLoadDirective: (MetacelloLinearLoadDirective loader: aLoader) during: aBlock.! !

!MetacelloLoaderPolicy methodsFor: 'private' stamp: 'DaleHenrichs 3/9/2010 15:33'!
pushLoadDirective: aLoaderDirective during: aBlock

	|  oldRoot |
	self loadDirective add: aLoaderDirective.
	oldRoot := loadDirective.
	loadDirective := aLoaderDirective.
	aBlock ensure: [ loadDirective := oldRoot ].! !

!MetacelloLoaderPolicy methodsFor: 'accessing' stamp: 'DaleHenrichs 3/5/2010 15:11'!
repositoryMap

	repositoryMap == nil ifTrue: [ repositoryMap := Dictionary new ].
	^repositoryMap! !

!MetacelloLoaderPolicy methodsFor: 'accessing' stamp: 'DaleHenrichs 3/5/2010 10:51'!
repositoryMap: anObject
	repositoryMap := anObject! !

!MetacelloLoaderPolicy methodsFor: 'accessing' stamp: 'DaleHenrichs 03/08/2010 16:23'!
resetCacheGofer

	cacheGofer := nil! !

!MetacelloLoaderPolicy methodsFor: 'accessing' stamp: 'DaleHenrichs 3/11/2010 19:35'!
silently

	silently == nil ifTrue: [ silently := false ].
	^ silently! !

!MetacelloLoaderPolicy methodsFor: 'accessing' stamp: 'DaleHenrichs 3/11/2010 19:35'!
silently: anObject
	silently := anObject! !

Object subclass: #MetacelloMCVersionSpecLoader
	instanceVariableNames: 'versionSpec required packages loader loaderPolicy'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metacello-MC-Loaders'!

!MetacelloMCVersionSpecLoader class methodsFor: 'instance creation' stamp: 'dkh 6/18/2009 09:53'!
on: aVersionSpec

	^(self new) 
		versionSpec: aVersionSpec;
		yourself! !

!MetacelloMCVersionSpecLoader methodsFor: 'accessing' stamp: 'DaleHenrichs 3/10/2010 11:19'!
label

	^self versionSpec label! !

!MetacelloMCVersionSpecLoader methodsFor: 'loading' stamp: 'DaleHenrichs 4/14/2010 17:17'!
load

	| mcLoader |
	packages := Dictionary new.
	self resolveToLoadableSpecs.
	mcLoader := self loader.
	mcLoader ignoreImage
		ifFalse: [ 
			packages values do: [:pkg | 
				pkg ensureLoadedForDevelopmentUsing: mcLoader.
				(pkg 
					compareCurrentVersion: self operator 
					targetVersionStatus: #(allLoadedToSpec) 
					using: mcLoader) 
						ifTrue: [ packages removeKey: pkg name ]]].
	packages notEmpty
		ifTrue: [
			mcLoader preLoad: self versionSpec.
			mcLoader load.
			mcLoader postLoad: self versionSpec ].
	^mcLoader! !

!MetacelloMCVersionSpecLoader methodsFor: 'accessing' stamp: 'DaleHenrichs 3/6/2010 08:41'!
loader

	loader == nil 
		ifTrue: [
			loader := self versionSpec loader copy.
			loader spec: self.
			loaderPolicy notNil ifTrue: [ loader loaderPolicy: loaderPolicy] ].
	^loader! !

!MetacelloMCVersionSpecLoader methodsFor: 'accessing' stamp: 'DaleHenrichs 3/6/2010 08:41'!
loaderPolicy
	^ loaderPolicy! !

!MetacelloMCVersionSpecLoader methodsFor: 'accessing' stamp: 'DaleHenrichs 3/6/2010 08:41'!
loaderPolicy: anObject
	loaderPolicy := anObject! !

!MetacelloMCVersionSpecLoader methodsFor: 'accessing' stamp: 'dkh 07/03/2009 10:12'!
name

	^self versionSpec name! !

!MetacelloMCVersionSpecLoader methodsFor: 'accessing' stamp: 'dkh 08/10/2009 15:13'!
operator

	^self loader operator! !

!MetacelloMCVersionSpecLoader methodsFor: 'accessing' stamp: 'DaleHenrichs 3/11/2010 23:46'!
packages

	^packages! !

!MetacelloMCVersionSpecLoader methodsFor: 'spec compatibility' stamp: 'dkh 8/13/2009 00:37'!
packageSpecsInLoadOrder

	| loadOrder packageNames |
	loadOrder := self versionSpec packages ~~ nil
		ifTrue: [ self versionSpec packages packageSpecsInLoadOrder ]
		ifFalse: [ OrderedCollection new ].
	packageNames := packages values collect: [:pkg | pkg name ].
	^loadOrder select: [:pkg | packageNames includes: pkg name ]! !

!MetacelloMCVersionSpecLoader methodsFor: 'accessing' stamp: 'dkh 6/12/2009 14:20'!
project

	^self versionSpec project! !

!MetacelloMCVersionSpecLoader methodsFor: 'loading' stamp: 'dkh 6/18/2009 11:04'!
repositories

	^self repositorySpecs! !

!MetacelloMCVersionSpecLoader methodsFor: 'spec compatibility' stamp: 'dkh 1/12/2010 17:25'!
repositorySpecs

	| repositoryMap |
	repositoryMap := self versionSpec repositories ~~ nil
		ifTrue: [ self versionSpec repositories map ]
		ifFalse: [ Dictionary new ].
	^repositoryMap values.! !

!MetacelloMCVersionSpecLoader methodsFor: 'accessing' stamp: 'dkh 6/9/2009 11:13'!
required

	required == nil ifTrue: [ ^#() ].
	^ required! !

!MetacelloMCVersionSpecLoader methodsFor: 'accessing' stamp: 'dkh 6/8/2009 16:57'!
required: anObject
	required := anObject! !

!MetacelloMCVersionSpecLoader methodsFor: 'loading' stamp: 'dkh 10/3/2009 19:54'!
resolvePackageNames

	packages := Dictionary new.
	self resolveToLoadableSpecs.
	^packages values collect: [:pkg | pkg name ]! !

!MetacelloMCVersionSpecLoader methodsFor: 'private' stamp: 'DaleHenrichs 1/19/2010 11:57'!
resolveToLoadableSpecs

	self versionSpec resolveToLoadableSpecs: required map: packages! !

!MetacelloMCVersionSpecLoader methodsFor: 'accessing' stamp: 'dkh 6/8/2009 16:55'!
versionSpec
	^ versionSpec! !

!MetacelloMCVersionSpecLoader methodsFor: 'accessing' stamp: 'dkh 6/8/2009 16:55'!
versionSpec: anObject
	versionSpec := anObject! !

!MetacelloMCVersionSpecLoader methodsFor: 'spec compatibility' stamp: 'DaleHenrichs 3/11/2010 17:49'!
versionString

	^self versionSpec versionString! !

Object subclass: #MetacelloVisitedPackages
	instanceVariableNames: 'groups packages projects'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metacello-MC-Specs'!

!MetacelloVisitedPackages methodsFor: 'initialize-release' stamp: 'dkh 10/21/2009 15:17'!
initialize

	groups := Set new.
	packages := Set new.
	projects := Set new.! !

!MetacelloVisitedPackages methodsFor: 'visiting' stamp: 'dkh 10/22/2009 08:31'!
pushProject: aBlock

	| oldGroups oldPackages oldProjects |
	oldGroups := groups.
	oldPackages := packages.
	oldProjects := projects.
	groups := Set new.
	packages := Set new.
	^aBlock ensure: [
		groups := oldGroups.
		packages := oldPackages.
		projects := oldProjects ]! !

!MetacelloVisitedPackages methodsFor: 'visiting' stamp: 'dkh 10/21/2009 15:26'!
visit: aSpec doing: aBlock

	aSpec
		projectDo: [:spec | 
			(projects includes: spec name) ifTrue: [ ^self ].
			projects add: spec name ] 
		packageDo: [:spec | 
			(packages includes: spec name) ifTrue: [ ^self ].
			packages add: spec name ] 
		groupDo: [:spec | 
			(groups includes: spec name) ifTrue: [ ^self ].
			groups add: spec name ].
	aBlock value: aSpec! !

!Object class methodsFor: '*metacello-mc' stamp: 'dkh 11/03/2009 11:05'!
lastMetacelloVersionLoad
	"Answer the last version loaded and the list of packages loaded for that version.
	 See MetacelloConfigTemplate."

	^nil -> 'default'! !

!Object class methodsFor: '*metacello-mc' stamp: 'dkh 11/3/2009 10:12'!
metacelloVersion: versionString loads: anArrayOrString
	"Stash the last version loaded and the list of packages loaded for that version. The list
	 of packages will be used by the tools when doing 'Load Package Version'.
	See MetacelloConfigTemplate for example"
	
	"noop by default"! !

MetacelloProjectSpec subclass: #MetacelloMCProjectSpec
	instanceVariableNames: 'projectPackage'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metacello-MC-Specs'!

!MetacelloMCProjectSpec methodsFor: 'accessing' stamp: 'DaleHenrichs 3/11/2010 23:10'!
className: aString

	super className: aString.
	(projectPackage ~~ nil and: [ projectPackage getFile == nil ])
		ifTrue: [ projectPackage file: aString ]! !

!MetacelloMCProjectSpec methodsFor: 'testing' stamp: 'Dalehenrichs 02/10/2010 11:52'!
compareCurrentVersion: anOperator targetVersionStatus: targetVersionStatus using: anMCLoader

	| cv vrsn prjct |
	(vrsn := self version) == nil ifTrue: [ ^false ].
	prjct := self projectClassProject.
	prjct loader: anMCLoader.
	(cv := prjct currentVersion) == nil ifTrue: [ ^false ].
	(targetVersionStatus includes: cv versionStatus)
		ifTrue: [ ^cv perform: anOperator with: vrsn ].
	^false! !

!MetacelloMCProjectSpec methodsFor: 'testing' stamp: 'DaleHenrichs 2/5/2010 14:02'!
compareRelativeCurrentVersion: anOperator targetVersionStatus: targetVersionStatus using: anMCLoader

	| cv vrsn |
	(vrsn := self version) == nil ifTrue: [ ^false ].
	(cv := self relativeCurrentVersion) == nil ifTrue: [ ^false ].
	(targetVersionStatus includes: cv versionStatus)
		ifTrue: [ ^cv perform: anOperator with: vrsn ].
	^false! !

!MetacelloMCProjectSpec methodsFor: 'loading' stamp: 'DaleHenrichs 3/17/2010 10:52'!
determineCurrentVersionForLoad
	"don't use self currentVersion, because we are interested in the currentVersion of the project as loaded in image, not the current version relative to our load list"
	
	| prjct version currentVersion packageAndProjectNames cvs |
	self projectClass == nil ifTrue: [ ^nil ].
	(version := self version) == nil ifTrue: [ ^nil ].
	version blessing == #baseline ifTrue: [ ^version ].
	prjct := self projectClass new project.
	prjct loader: self loader.
	(currentVersion := prjct currentVersion) == nil ifTrue: [ ^nil ].
	(cvs := currentVersion versionStatus) == #somethingLoaded ifTrue: [ ^nil ].
	(#(allLoadedToSpec loadedToSpec loadedMatchConstraints) includes: (cvs := currentVersion versionStatus)) 
		ifTrue: [ 
			(currentVersion perform: self operator with: version)
				ifTrue: [ "load currentVersion" ^currentVersion ].
			"load version" ^nil ].
	version = currentVersion ifTrue: [ ^currentVersion ].
	(MetacelloProjectSpecLoadConflict projectSpec: self) 
		signal: 
			'Project load conflict for', 
			prjct label printString,  
			' between current version ',
			currentVersion printString, 
			'(', 
			cvs asString, 
			') and specified version ', 
			version printString,
			'. Press resume to continue with load anyway'.
	^nil! !

!MetacelloMCProjectSpec methodsFor: 'loading' stamp: 'DaleHenrichs 3/11/2010 17:27'!
ensureLoadedForDevelopmentUsing: mcLoader
	"for #development projects, always need latest version of package when contemplating a load"

	| ensured |
	ensured := mcLoader ensuredMap at: self name ifAbsent: [ nil ].
	self projectClass ~~ nil
		ifTrue: [  | vrsn |
			vrsn := self version.
			(vrsn ~~ nil and: [ vrsn blessing == #development ])
				ifTrue: [ 
					ensured ~~ #latest
						ifTrue: [
							mcLoader ensureForDevelopment
								ifTrue: [ self projectPackage loadUsing: mcLoader ]
								ifFalse: [ self projectPackage fetchUsing: mcLoader ].
							mcLoader ensuredMap at: self name put: #latest ].
					^self]].
	ensured == nil
		ifTrue:  [ 
			mcLoader ensureForDevelopment
				ifTrue: [ self projectPackage loadUsing: mcLoader ]
				ifFalse: [ self projectPackage fetchUsing: mcLoader ].
			mcLoader ensuredMap at: self name put: #present ]! !

!MetacelloMCProjectSpec methodsFor: 'loading' stamp: 'DaleHenrichs 3/6/2010 10:28'!
ensureProjectLoaded
	"Ensure that the MetacelloProject is loaded in image. 
	 projectClass == nil or requested version non-existent warrants a project package load."

	(self projectClass == nil or: [self version == nil])
		ifTrue: [ 
			self projectPackage load.
			^true ].
	^false! !

!MetacelloMCProjectSpec methodsFor: 'querying' stamp: 'dkh 10/24/2009 20:19'!
file
	
	^self projectPackage file! !

!MetacelloMCProjectSpec methodsFor: 'accessing' stamp: 'dkh 10/7/2009 01:01'!
file: aString

	self projectPackage name: aString! !

!MetacelloMCProjectSpec methodsFor: 'testing' stamp: 'dkh 5/14/2010 16:09'!
isPartiallyLoaded: aLoader

	| vrsn |
	(vrsn := self version) == nil ifTrue: [ ^false ].
	(self loadListForVersion: vrsn) do: [:nm |
		(vrsn packagesForSpecNamed: nm ) do: [:pkg |
			(pkg isPackageLoaded: aLoader) ifTrue: [ ^true ]]].
	^false! !

!MetacelloMCProjectSpec methodsFor: 'testing' stamp: 'dkh 12/14/2009 12:06'!
isPossibleBaseline

	| vrsn |
	(vrsn := self version) == nil ifTrue: [ ^false ].
	(vrsn allPackagesForSpecNamed: (self loadListForVersion: vrsn)) do: [:pkg |
		pkg workingCopy == nil ifTrue: [ ^false ]].
	^true! !

!MetacelloMCProjectSpec methodsFor: 'loading' stamp: 'DaleHenrichs 03/08/2010 17:21'!
load

	| displayString |
	displayString := 'Project: ', self name.
	self versionString ~~ nil ifTrue: [ displayString := displayString, ' ', self versionString ].
	Transcript cr; show: displayString.
	self ensureProjectLoaded.
	self loadVersion: self determineCurrentVersionForLoad! !

!MetacelloMCProjectSpec methodsFor: 'accessing' stamp: 'DaleHenrichs 6/24/2010 13:46'!
loadedPackageNames: aLoader

	| vrsn pkgs |
	(vrsn := self version) == nil ifTrue: [ ^#() ].
	pkgs := OrderedCollection new.
	(self loadListForVersion: vrsn) do: [:nm |
		(vrsn packagesForSpecNamed: nm ) do: [:pkg |
			(pkg isPackageLoaded: aLoader) ifTrue: [ pkgs add: pkg name ]]].
	^pkgs! !

!MetacelloMCProjectSpec methodsFor: 'private' stamp: 'dkh 10/21/2009 19:20'!
loadListForVersion: vrsn 

	^ (self loads == nil
			or: [self loads isEmpty])
		ifTrue: [vrsn spec defaultPackageNames]
		ifFalse: [self loads]! !

!MetacelloMCProjectSpec methodsFor: 'accessing' stamp: 'DaleHenrichs 6/24/2010 13:45'!
loadPackageList

	| vrsn pkgs |
	(vrsn := self version) == nil ifTrue: [ ^#() ].
	pkgs := OrderedCollection new.
	(self loadListForVersion: vrsn) do: [:nm |
		pkgs addAll: ((vrsn packagesForSpecNamed: nm ) collect: [:each | each name ])].
	^pkgs! !

!MetacelloMCProjectSpec methodsFor: 'loading' stamp: 'DaleHenrichs 6/24/2010 17:23'!
loadVersion: aVersionOrNil
	"Load the correct version of the project"

	| vrsn mcLoader loadedPackageNames loadedProjectNames list projectMap |
	vrsn := aVersionOrNil .
	vrsn == nil
		ifTrue: [ 
			(vrsn := self version) == nil
				ifTrue: [
					 ^(MetacelloProjectSpecLoadError projectSpec: self) 
						signal: 'No version found for ', 
									self versionString printString, 
									' of ', 
									self className asString ]].
	mcLoader := self loader copy.
	mcLoader operator: self operator.
	vrsn loader: mcLoader.
	loadedPackageNames := (vrsn packages select: [:pkg | pkg isPackageLoaded: mcLoader ]) 
		collect: [:pkg | pkg name ].
	projectMap := Dictionary new.
	vrsn projects do: [:prj | 
		prj className ~~ nil
			ifTrue: [ | coll loaded |
				coll := projectMap at: prj className ifAbsent: [
					coll := OrderedCollection new.
					projectMap at: prj className put: coll.
					coll].
				(loaded := prj loadedPackageNames: mcLoader) isEmpty 
					ifFalse: [  coll add: prj -> (loaded -> prj loadPackageList) ]]].
	loadedProjectNames := OrderedCollection new.
	projectMap keysAndValuesDo: [:prjClass :coll |
		coll size <= 1
			ifTrue: [ coll do: [:assoc | loadedProjectNames add: assoc key name ]]
			ifFalse: [ 
				"multiple project references against the same configuration ... only count project as loaded
				 if there is an exact match for loaded projects...
				 See http://code.google.com/p/metacello/issues/detail?id=86"
				coll do: [:assoc | | loaded packageList |
					loaded := assoc value key. "loaded packages from project"
					packageList := assoc value value. "loadlist for project"
					(packageList difference: loaded) isEmpty
						ifTrue: [ loadedProjectNames add: assoc key name ]]]].
	list := loadedPackageNames, loadedProjectNames, (self loadListForVersion: vrsn).
	mcLoader preLoad: self.
	vrsn fetchRequiredFromArray: list.
	mcLoader postLoad: self.! !

!MetacelloMCProjectSpec methodsFor: 'merging' stamp: 'dkh 10/4/2009 12:05'!
mergeMap

	| map |
	map := super mergeMap.
	map at: #projectPackage put: projectPackage.
	^map! !

!MetacelloMCProjectSpec methodsFor: 'merging' stamp: 'dkh 10/9/2009 06:28'!
mergeSpec: anotherSpec

	| newSpec anotherProjectPackage map |
	newSpec := super mergeSpec: anotherSpec.
	map := anotherSpec mergeMap.
	(anotherProjectPackage := map at: #projectPackage) ~~ nil
		ifTrue: [ 
			newSpec projectPackage: 
				(newSpec projectPackage == nil
					ifTrue: [ anotherProjectPackage ]
					ifFalse: [ newSpec projectPackage mergeSpec: anotherProjectPackage ])].
	^newSpec! !

!MetacelloMCProjectSpec methodsFor: 'merging' stamp: 'dkh 10/8/2009 20:34'!
nonOverridable

	^super nonOverridable, #( projectPackage )! !

!MetacelloMCProjectSpec methodsFor: 'accessing' stamp: 'dkh 10/4/2009 11:44'!
packageFileSpecFor: aMetacelloPackagesSpec

	^(aMetacelloPackagesSpec project projectReferenceSpec)
			name: self name;
			projectReference: self copy;
			yourself.! !

!MetacelloMCProjectSpec methodsFor: 'querying' stamp: 'dkh 11/12/2009 16:56'!
packageRepository
	
	^nil! !

!MetacelloMCProjectSpec methodsFor: 'querying' stamp: 'dkh 06/17/2009 15:35'!
projectClass

	^Smalltalk at: self className asSymbol  ifAbsent: []! !

!MetacelloMCProjectSpec methodsFor: 'querying' stamp: 'dkh 9/10/2009 13:18'!
projectClassProject
	"indirection needed when projectClass is _not_ a subclass of MetacelloProject"
	
	^self projectClass new project! !

!MetacelloMCProjectSpec methodsFor: 'visiting' stamp: 'dkh 10/21/2009 15:53'!
projectDo: projectBlock packageDo: packageBlock groupDo: groupBlock

	projectBlock value: self! !

!MetacelloMCProjectSpec methodsFor: 'querying' stamp: 'dkh 6/7/2009 09:19'!
projectPackage
	^ projectPackage! !

!MetacelloMCProjectSpec methodsFor: 'accessing' stamp: 'dkh 6/7/2009 09:19'!
projectPackage: anObject
	projectPackage := anObject! !

!MetacelloMCProjectSpec methodsFor: 'querying' stamp: 'DaleHenrichs 2/5/2010 13:38'!
relativeCurrentVersion
	"currentVersion calculated relative to the loadList"
	
	| vrsn |
	(vrsn := self version) == nil ifTrue: [ ^nil ].
	^self projectClassProject currentVersionAgainst: 
		(vrsn expandToLoadableSpecNames:  
			(self loadListForVersion: vrsn))! !

!MetacelloMCProjectSpec methodsFor: 'querying' stamp: 'dkh 1/2/2010 15:36'!
repository
	
	^self projectPackage packageRepository! !

!MetacelloMCProjectSpec methodsFor: 'accessing' stamp: 'dkh 10/7/2009 01:02'!
repository: aString

	self projectPackage repository: aString! !

!MetacelloMCProjectSpec methodsFor: 'accessing' stamp: 'dkh 10/22/2009 09:39'!
repository: aString username: username password: password

	self projectPackage repository: aString username: username password: password! !

!MetacelloMCProjectSpec methodsFor: 'private' stamp: 'DaleHenrichs 1/22/2010 11:32'!
resolveToAllPackagesIn: aVersionSpec visited: visited

	| vrsn |
	visited pushProject: [
		visited
			visit: self
			doing: [:spec |
				spec ensureProjectLoaded.
				(vrsn := spec version) == nil ifTrue: [ ^#() ].
				^vrsn
					allPackagesForSpecNamed: (self loadListForVersion: vrsn)		
					ifAbsent: [ self error: 'invalid loads: spec' ]]].
	^#()! !

!MetacelloMCProjectSpec methodsFor: 'private' stamp: 'dkh 11/12/2009 10:12'!
resolveToLoadableSpec

	^self copy! !

!MetacelloMCProjectSpec methodsFor: 'development support' stamp: 'dkh 11/21/2009 11:37'!
updateForSpawnMethod: sourceSpec
	"just pick up the versionString from the sourceSpec"
	
	className := operator := loads := projectPackage := nil.
	sourceSpec ~~ nil ifTrue: [ versionString := sourceSpec versionString ].! !

!MetacelloMCProjectSpec methodsFor: 'development support' stamp: 'dkh 11/21/2009 09:58'!
updatePackageSpec: updatedSpecs
	"Add project copy to updatedSpecs if the current version of the project 
	 is different from the receiver's version"
	
	|  prj currentVersion spec |
	self className == nil ifTrue: [ ^self ].
	prj := self projectClassProject.
	(currentVersion := prj currentVersion) = self version
		ifTrue: [ ^self ].
	currentVersion == nil ifTrue: [ ^self ].
	spec := self copy.
	spec versionString: currentVersion versionString.
	updatedSpecs at: spec name put: spec! !

!MetacelloMCProjectSpec methodsFor: 'querying' stamp: 'SeanDeNigris 8/17/2010 16:15'!
version
	"Empty version string means use latestVersion or lastVersion"

	self projectClass == nil ifTrue: [ ^nil ].
	^self versionString == nil
		ifTrue: [ | vrsn |
			(vrsn := self projectClassProject stableVersion) == nil
				ifTrue: [ self projectClassProject bleedingEdge ]
				ifFalse: [ vrsn ]]
		ifFalse: [ self projectClassProject version: self versionString ]! !

!Collection methodsFor: '*metacello-mc' stamp: 'dkh 6/7/2009 10:16'!
addToMetacelloRepositories: aMetacelloRepositoriesSpec

	self do: [:each | each addToMetacelloRepositories: aMetacelloRepositoriesSpec ]! !

!Collection methodsFor: '*metacello-mc' stamp: 'DaleHenrichs 3/7/2010 08:26'!
fetchRequiredForMetacelloMCVersion: aMetacelloMCVersion

	^aMetacelloMCVersion doFetchRequiredFromArray: self.! !

!Collection methodsFor: '*metacello-mc' stamp: 'DaleHenrichs 3/4/2010 15:37'!
loadRequiredForMetacelloMCVersion: aMetacelloMCVersion

	^aMetacelloMCVersion doLoadRequiredFromArray: self.! !

!Collection methodsFor: '*metacello-mc' stamp: 'dkh 6/7/2009 10:19'!
mergeIntoMetacelloRepositories: aMetacelloRepositoriesSpec

	self do: [:each | each mergeIntoMetacelloRepositories: aMetacelloRepositoriesSpec ]! !

!Collection methodsFor: '*metacello-mc' stamp: 'DaleHenrichs 3/11/2010 10:06'!
recordRequiredForMetacelloMCVersion: aMetacelloMCVersion

	^aMetacelloMCVersion doRecordRequiredFromArray: self.! !

!Collection methodsFor: '*metacello-mc' stamp: 'dkh 6/7/2009 10:23'!
removeFromMetacelloRepositories: aMetacelloRepositoriesSpec

	self do: [:each | each removeFromMetacelloRepositories: aMetacelloRepositoriesSpec ]! !

!Collection methodsFor: '*metacello-mc' stamp: 'dkh 10/21/2009 19:18'!
resolvePackageSpecsNamedForMetacelloMCVersion: aMetacelloMCVersion visited: visited ifAbsent: aBlock 

	^ aMetacelloMCVersion
		allPackagesForSpecs: (self collect: [:ea | 
			aMetacelloMCVersion spec packageNamed: ea ifAbsent: aBlock])
		visited: visited! !

MetacelloSpecLoader subclass: #MetacelloCommonMCSpecLoader
	instanceVariableNames: 'operator loaderPolicy disablePackageCache'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metacello-MC-Loaders'!

!MetacelloCommonMCSpecLoader class methodsFor: 'utilities' stamp: 'dkh 9/10/2009 17:23'!
nameComponentsFrom: aVersionName
	| ar |
	ar := (aVersionName last isDigit and: [ (aVersionName indexOf: $.) > 0 ])ifFalse: [Array with: aVersionName with: '' with: 0 with: aVersionName with: self]
		ifTrue: [ | vrsn str |
			str := ((aVersionName copyAfterLast: $-) copyAfterLast: $.).
			vrsn := str isEmpty
				ifTrue: [0]
				ifFalse: [str asInteger].
			Array
				with: (aVersionName copyUpToLast:  $-)								"base pkg name"
				with: ((aVersionName copyAfterLast: $-) copyUpTo: $.)				"user"
				with:  vrsn "version"
				with: aVersionName
				with: self ].
	^ar! !

!MetacelloCommonMCSpecLoader methodsFor: 'versionInfo' stamp: 'dkh 9/25/2009 11:27'!
currentVersionInfoFor: packageSpec

	^packageSpec currentVersionInfo! !

!MetacelloCommonMCSpecLoader methodsFor: 'actions' stamp: 'TestRunner 10/23/2009 11:33'!
doingLoads: aBlock
	"escape mechanism for recording and null loaders to skip doing loaderlike things"
	
	aBlock value! !

!MetacelloCommonMCSpecLoader methodsFor: 'actions' stamp: 'DaleHenrichs 3/10/2010 15:16'!
doLoad

	self subclassResponsibility! !

!MetacelloCommonMCSpecLoader methodsFor: 'testing' stamp: 'DaleHenrichs 3/11/2010 20:48'!
ensureForDevelopment

	^true! !

!MetacelloCommonMCSpecLoader methodsFor: 'accessing' stamp: 'DaleHenrichs 3/10/2010 14:29'!
fetchingSpecLoader

	^self! !

!MetacelloCommonMCSpecLoader methodsFor: 'testing' stamp: 'DaleHenrichs 3/10/2010 14:40'!
hasRepositoryOverrides

	^self loaderPolicy hasRepositoryOverrides! !

!MetacelloCommonMCSpecLoader methodsFor: 'accessing' stamp: 'DaleHenrichs 4/12/2010 11:30'!
ignoreImage

	^self loaderPolicy ignoreImage! !

!MetacelloCommonMCSpecLoader methodsFor: 'initialize-release' stamp: 'DaleHenrichs 3/10/2010 14:41'!
initialize

	self loaderPolicy! !

!MetacelloCommonMCSpecLoader methodsFor: 'actions' stamp: 'DaleHenrichs 4/9/2010 12:17'!
linearLoadPackageSpec: packageSpec gofer: gofer

	self subclassResponsibility! !

!MetacelloCommonMCSpecLoader methodsFor: 'private' stamp: 'DaleHenrichs 3/5/2010 09:45'!
linearLoadPackageSpecs: packageSpecs repositories: repositories
	
	| gofer |
	gofer := Gofer new.
	repositories do: [:repo | gofer repository: repo ].
	packageSpecs do: [:pkg | pkg loadUsing: self gofer: gofer ].! !

!MetacelloCommonMCSpecLoader methodsFor: 'actions' stamp: 'DaleHenrichs 3/10/2010 14:33'!
load
	| repos |
	repos := self repositoriesFrom: self spec repositorySpecs.
	^ self loadType == #atomic
		ifTrue: [self atomicLoadPackageSpecs: self spec packageSpecsInLoadOrder repositories: repos]
		ifFalse: ["assume #linear"
			self linearLoadPackageSpecs: self spec packageSpecsInLoadOrder repositories: repos ]! !

!MetacelloCommonMCSpecLoader methodsFor: 'accessing' stamp: 'DaleHenrichs 3/10/2010 14:35'!
loaderPolicy

	loaderPolicy == nil ifTrue: [ loaderPolicy := MetacelloLoaderPolicy new ].
	^loaderPolicy! !

!MetacelloCommonMCSpecLoader methodsFor: 'accessing' stamp: 'DaleHenrichs 3/10/2010 14:35'!
loaderPolicy: anObject
	loaderPolicy := anObject! !

!MetacelloCommonMCSpecLoader methodsFor: 'accessing' stamp: 'DaleHenrichs 3/6/2010 07:43'!
loadingSpecLoader

	^self! !

!MetacelloCommonMCSpecLoader methodsFor: 'actions' stamp: 'DaleHenrichs 4/9/2010 12:07'!
loadPackageDirective: aPackageLoadDirective gofer: aGofer

	| packageSpec |
	packageSpec := aPackageLoadDirective spec.
	MetacelloPlatform current
		do:  [ | loadBlock goferLoad answers resolvedReference |
			aGofer disablePackageCache. "for good luck:)"
			resolvedReference := self resolvePackageSpec: packageSpec gofer: aGofer.
			resolvedReference isNil ifTrue: [ "Package version already loaded into image" ^self ].
			loadBlock := [
				"mcLoader preLoad: packageSpec."
				goferLoad := MetacelloGoferLoad on: Gofer new.
				goferLoad addResolved: resolvedReference.
				goferLoad execute.
				MetacelloPlatform current clearCurrentVersionCache.
				"mcLoader postLoad: packageSpec" ].
			(answers := packageSpec answers) notEmpty
				ifTrue: [ loadBlock valueSupplyingMetacelloAnswers: answers ]
				ifFalse: [ loadBlock value].
			resolvedReference workingCopy repositoryGroup addRepository:  aPackageLoadDirective repository.
			Transcript cr; show: 'Loaded -> ', resolvedReference name, ' --- ', aPackageLoadDirective repository description, ' --- ', resolvedReference repository description  ]
		displaying: 'Loading ', packageSpec file! !

!MetacelloCommonMCSpecLoader methodsFor: 'actions' stamp: 'DaleHenrichs 4/9/2010 12:12'!
loadPackageDirectives: pkgLoads gofer: aGofer

	MetacelloPlatform current
		do:  [ | goferLoad loadBlock answers |
			goferLoad := MetacelloGoferLoad on: aGofer.
			answers := OrderedCollection new.
			pkgLoads do: [:packageLoadDirective | | resolvedReference |
				aGofer disablePackageCache. "for good luck:)"
				(resolvedReference := self 
						resolvePackageSpec: packageLoadDirective spec 
						gofer: aGofer) ~~ nil
					ifTrue: [ 
						goferLoad addResolved: resolvedReference.
						answers addAll: packageLoadDirective spec answers.
						packageLoadDirective resolvedReference:  resolvedReference ]].
			Transcript cr; show: 'Starting atomic load'.
			loadBlock := [
				"pkgLoads do: [:packageLoadDirective |  mcLoader preLoad: packageLoadDirective spec ]."
				goferLoad execute.
				pkgLoads do: [:packageLoadDirective |
					packageLoadDirective resolvedReference == nil
						ifTrue: [ Transcript cr; tab; show: 'Already Loaded -> ', packageLoadDirective file ]
						ifFalse: [ Transcript cr; tab; show: 'Loaded -> ', packageLoadDirective file, ' --- ',  packageLoadDirective repository description, ' --- ', packageLoadDirective resolvedReference repository description.
					packageLoadDirective resolvedReference workingCopy repositoryGroup addRepository: packageLoadDirective repository ]].
				MetacelloPlatform current clearCurrentVersionCache.
				"pkgLoads do: [:packageLoadDirective | 
					packageLoadDirective resolvedReference ~~ nil
						ifTrue: [mcLoader postLoad: packageLoadDirective spec ]]"].
			answers notEmpty
				ifTrue: [ loadBlock valueSupplyingMetacelloAnswers: answers ]
				ifFalse: [ loadBlock value].
			Transcript cr; show: 'Finished atomic load' ]
		displaying: 'Atomic Load...'.! !

!MetacelloCommonMCSpecLoader methodsFor: 'packages' stamp: 'dkh 07/22/2009 14:50'!
nameComponentsFrom: aVersionName

	^self class nameComponentsFrom: aVersionName! !

!MetacelloCommonMCSpecLoader methodsFor: 'accessing' stamp: 'dkh 08/10/2009 15:06'!
operator

	operator == nil ifTrue: [ ^#= ].
	^operator! !

!MetacelloCommonMCSpecLoader methodsFor: 'accessing' stamp: 'dkh 08/10/2009 15:06'!
operator: aSymbol

	operator := aSymbol! !

!MetacelloCommonMCSpecLoader methodsFor: 'doits' stamp: 'DaleHenrichs 03/12/2010 16:43'!
postLoad: packageOrVersionSpec
	"subclassResponsibility, but it gets called during an upgrade, so leave it as NOOP"! !

!MetacelloCommonMCSpecLoader methodsFor: 'doits' stamp: 'DaleHenrichs 3/10/2010 14:32'!
preLoad: packageOrVersionSpec

	self subclassResponsibility! !

!MetacelloCommonMCSpecLoader methodsFor: 'accessing' stamp: 'DaleHenrichs 3/11/2010 16:37'!
recordingSpecLoader

	^(MetacelloNullRecordingMCSpecLoader on: self spec)
		shouldDisablePackageCache: self shouldDisablePackageCache;
		loaderPolicy: self loaderPolicy copy;
		yourself! !

!MetacelloCommonMCSpecLoader methodsFor: 'repositories' stamp: 'DaleHenrichs 3/10/2010 14:42'!
repositoriesFrom: aMetacelloMVRepositorySpecs

	^self repositoriesFrom: aMetacelloMVRepositorySpecs ignoreOverrides: false! !

!MetacelloCommonMCSpecLoader methodsFor: 'repositories' stamp: 'DaleHenrichs 3/10/2010 14:42'!
repositoriesFrom: aMetacelloMVRepositorySpecs ignoreOverrides: ignoreOverrides

	| repositories repos |
	(ignoreOverrides not and: [self hasRepositoryOverrides]) ifTrue: [ ^self loaderPolicy overrideRepositories ].
	repositories := MCRepositoryGroup default repositories.
	repos := OrderedCollection new.
	aMetacelloMVRepositorySpecs do: [:aSpec | | description repo |
		description := aSpec description.
		(repo := repositories detect: [:rep | rep description = description ] ifNone: [ aSpec createRepository ]) ~~ nil
			ifTrue: [ repos add: repo ]].
	^repos! !

!MetacelloCommonMCSpecLoader methodsFor: 'accessing' stamp: 'DaleHenrichs 3/10/2010 14:43'!
repositoryMap

	^self loaderPolicy repositoryMap! !

!MetacelloCommonMCSpecLoader methodsFor: 'private' stamp: 'DaleHenrichs 6/15/2010 10:29'!
resolvePackageSpec: packageSpec gofer: gofer

	|  references resolvedReference loadedVersionInfo mcVersion |
	references := self retryingResolvePackageSpecReferences: packageSpec gofer: gofer.
	resolvedReference := references last asMetacelloCachingResolvedReference.
	mcVersion := resolvedReference version.
	(loadedVersionInfo := self currentVersionInfoFor: packageSpec) ~~ nil
		ifTrue: [ 
			loadedVersionInfo name = mcVersion info name 
				ifTrue: [ 
					"package already loaded, don't load again"
					^nil ]].
	^resolvedReference! !

!MetacelloCommonMCSpecLoader methodsFor: 'private' stamp: 'DaleHenrichs 3/10/2010 14:43'!
resolvePackageSpecReferences: packageSpec gofer: gofer

	|  versionReference references localGofer |
	localGofer := gofer.
	self hasRepositoryOverrides not
		ifTrue: [
			packageSpec repositorySpecs notEmpty
				ifTrue: [ 
					localGofer := Gofer new.
					(self repositoriesFrom: packageSpec repositorySpecs) do: [:repo | localGofer repository: repo ]]].
	(packageSpec getFile == nil or: [ self shouldDisablePackageCache ])
		ifTrue: [ 
			"don't use package-cache when trying to get latest version"
			localGofer disablePackageCache ].
	versionReference := packageSpec goferLoaderReference.
	references := versionReference resolveAllWith: localGofer.
	localGofer enablePackageCache.
	^references! !

!MetacelloCommonMCSpecLoader methodsFor: 'private' stamp: 'DaleHenrichs 6/15/2010 11:00'!
retryingResolvePackageSpecReferences: packageSpec gofer: gofer

	| retryCount references repositoryError |
	retryCount := 0.
	references := #().
	[references isEmpty
		and: [retryCount < 3]]
		whileTrue: [retryCount > 0
				ifTrue: [Transcript cr; show: '...RETRY'].
			references := [self resolvePackageSpecReferences: packageSpec gofer: gofer]
						on: Error , GoferRepositoryError
						do: [:ex | 
							retryCount >= 2
								ifTrue: [(ex isKindOf: GoferRepositoryError)
										ifTrue: [
											"ignore repository errors at this point, in case an alternate repository is in the list "
											Transcript cr; show: 'gofer repository error: ', ex description printString, '...ignoring'. 
											repositoryError := ex.
											ex resume: #()]
										ifFalse: [ex pass]].
							ex return: #()].
			retryCount := retryCount + 1].
	references isEmpty 
		ifTrue: [ 
			self error: 'Could not resolve: ', packageSpec name,
				(repositoryError == nil 
					ifTrue: [''] 
					ifFalse: [
						"report repository error to user here, since failure here is likely to be due to earlier repository error"
						' ERROR: ', repositoryError description printString ]) ].
	^references! !

!MetacelloCommonMCSpecLoader methodsFor: 'accessing' stamp: 'DaleHenrichs 3/10/2010 14:34'!
shouldDisablePackageCache

	disablePackageCache == nil ifTrue: [ disablePackageCache := false ].
	^ disablePackageCache! !

!MetacelloCommonMCSpecLoader methodsFor: 'accessing' stamp: 'DaleHenrichs 3/10/2010 14:34'!
shouldDisablePackageCache: anObject
	disablePackageCache := anObject! !

MetacelloCommonMCSpecLoader subclass: #MetacelloFetchingMCSpecLoader
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metacello-MC-Loaders'!

!MetacelloFetchingMCSpecLoader methodsFor: 'accessing' stamp: 'DaleHenrichs 3/11/2010 16:33'!
actionLabel

	^'Fetching '! !

!MetacelloFetchingMCSpecLoader methodsFor: 'private' stamp: 'DaleHenrichs 3/9/2010 12:23'!
atomicLoadPackageSpecs: packageSpecs repositories: repositories

	self loaderPolicy 
		pushAtomicLoadDirectivesDuring: [ super linearLoadPackageSpecs: packageSpecs repositories: repositories ]
		for: self! !

!MetacelloFetchingMCSpecLoader methodsFor: 'accessing' stamp: 'DaleHenrichs 3/10/2010 14:39'!
cacheRepository

	^self loaderPolicy cacheRepository! !

!MetacelloFetchingMCSpecLoader methodsFor: 'versionInfo' stamp: 'DaleHenrichs 3/10/2010 11:59'!
currentVersionInfoFor: packageSpec

	^self loadData
		currentVersionInfoFor: packageSpec 
		ifAbsent: [ super currentVersionInfoFor: packageSpec ]! !

!MetacelloFetchingMCSpecLoader methodsFor: 'actions' stamp: 'DaleHenrichs 3/10/2010 16:42'!
doLoad

	self loaderPolicy copy load! !

!MetacelloFetchingMCSpecLoader methodsFor: 'accessing' stamp: 'DaleHenrichs 3/10/2010 14:40'!
ensuredMap

	^self loaderPolicy ensuredMap! !

!MetacelloFetchingMCSpecLoader methodsFor: 'private' stamp: 'DaleHenrichs 3/21/2010 13:21'!
explicitLoadPackageSpecs: packageSpecs repositories: repositories
	
	| directive |
	directive := self loaderPolicy 
		pushExplicitLoadDirectivesDuring: [ super linearLoadPackageSpecs: packageSpecs repositories: repositories ]
		for: self.
	directive explicitLoadWithPolicy: self loaderPolicy.! !

!MetacelloFetchingMCSpecLoader methodsFor: 'actions' stamp: 'DaleHenrichs 6/15/2010 10:57'!
linearLoadPackageSpec: packageSpec gofer: gofer

	MetacelloPlatform current
		do:  [ | references nearestReference cachedReference loadedVersionInfo externalReference mcVersion |
			"check to see if mcz file is already in cacheRepository"
			cachedReference := self resolvePackageSpec: packageSpec cachedGofer: self loaderPolicy cacheGofer.
			(cachedReference ~~ nil and: [ packageSpec getFile ~~ nil ])
				ifTrue: [	 cachedReference name = packageSpec file ifTrue: [ ^self ]].
			"look up mcz file"
			references := self retryingResolvePackageSpecReferences: packageSpec gofer: gofer.
			nearestReference := references last asMetacelloCachingResolvedReference.
			"If the mcz is already in the cacheRepository, no need to copy"
			(cachedReference ~~ nil and: [ cachedReference name = nearestReference name ])
				ifTrue: [ ^self ].
			"If the mcz is already loaded into the image, no need to copy"
			(self ignoreImage not 
				and: [ (loadedVersionInfo := self currentVersionInfoFor: packageSpec) ~~ nil ])
					ifTrue: [ loadedVersionInfo name = nearestReference name ifTrue: [ ^self ]].
			externalReference := (references select: [:ref | ref name = nearestReference name]) first asMetacelloCachingResolvedReference.
			self repositoryMap at: externalReference name put: externalReference repository.
			(self resolveDependencies: externalReference into: (OrderedCollection with: nearestReference)) do: [:reference | | pSpec |
				mcVersion := reference version.
				self cacheRepository storeVersion: mcVersion.
				reference == nearestReference
					ifTrue: [ pSpec := packageSpec ]
					ifFalse: [ 
						pSpec :=  packageSpec project packageSpec.
						pSpec name: mcVersion info ].
				self loadData 
					addVersion: mcVersion 
					versionInfo: mcVersion info 
					resolvedReference: reference 
					packageSpec: pSpec ].
			self loaderPolicy resetCacheGofer.
			self preLoad: packageSpec.
			(MetacelloDirective loadPackage: packageSpec externalReference: externalReference loader: self) addTo: self loadDirective.
			self postLoad: packageSpec.
			Transcript cr; show: 'Fetched -> ', externalReference name, ' --- ', externalReference repository description, ' --- ', nearestReference repository description ]
		displaying: 'Fetching ', packageSpec file! !

!MetacelloFetchingMCSpecLoader methodsFor: 'private' stamp: 'DaleHenrichs 3/9/2010 12:39'!
linearLoadPackageSpecs: packageSpecs repositories: repositories
	
	self loaderPolicy 
		pushLinearLoadDirectivesDuring: [ super linearLoadPackageSpecs: packageSpecs repositories: repositories ]
		 for: self! !

!MetacelloFetchingMCSpecLoader methodsFor: 'accessing' stamp: 'DaleHenrichs 3/10/2010 11:58'!
loadData

	^self loaderPolicy loadData! !

!MetacelloFetchingMCSpecLoader methodsFor: 'accessing' stamp: 'DaleHenrichs 3/10/2010 14:36'!
loadDirective

	^self loaderPolicy loadDirective! !

!MetacelloFetchingMCSpecLoader methodsFor: 'accessing' stamp: 'DaleHenrichs 3/10/2010 10:25'!
loadingSpecLoader

	^(MetacelloLoadingMCSpecLoader on: self spec)
		shouldDisablePackageCache: self shouldDisablePackageCache;
		loaderPolicy: self loaderPolicy copy;
		yourself! !

!MetacelloFetchingMCSpecLoader methodsFor: 'doits' stamp: 'DaleHenrichs 3/11/2010 13:43'!
postLoad: packageOrVersionSpec

	(MetacelloDirective postLoadSpec: packageOrVersionSpec loader: self)  addTo: self loadDirective! !

!MetacelloFetchingMCSpecLoader methodsFor: 'doits' stamp: 'DaleHenrichs 3/11/2010 13:43'!
preLoad: packageOrVersionSpec

	(MetacelloDirective preLoadSpec: packageOrVersionSpec loader: self) addTo: self loadDirective! !

!MetacelloFetchingMCSpecLoader methodsFor: 'printing' stamp: 'DaleHenrichs 5/17/2010 16:42'!
printOn: aStream
	super printOn: aStream.
	aStream nextPut: $(.
	self loadDirective printOn: aStream.
	aStream nextPut: $)! !

!MetacelloFetchingMCSpecLoader methodsFor: 'private' stamp: 'DaleHenrichs 4/21/2010 13:17'!
resolveDependencies: aResolvedReference into: aCollection

	| block retryCount coll notDone |
	block := [ :dependency | | reference |
		reference := MetacelloCachingGoferResolvedReference
			name: dependency versionInfo name
			repository: aResolvedReference repository.
		coll add: reference.
		Transcript cr; show: 'Fetched dependency -> ', reference name, ' --- ', reference repository description.
		self resolveDependencies: reference into: coll].
	retryCount := 0.
	notDone := true.
	coll := OrderedCollection new.
	[ notDone and: [ retryCount < 3 ]]
		whileTrue: [
			retryCount > 0 ifTrue: [ Transcript cr; show: '...RETRY' ].
			[ 	
				"ensure that all resolved references have cached their version while wrapped by error handler"
				aCollection do: [:each | each version ]. 
				aResolvedReference version dependencies do: block.
				notDone := false ]
					on: Error 
					do: [:ex | 
						retryCount := retryCount + 1.
						retryCount >= 3 ifTrue: [ ex pass ].
						coll := OrderedCollection new ]].
	aCollection addAll: coll.
	^aCollection! !

!MetacelloFetchingMCSpecLoader methodsFor: 'private' stamp: 'DaleHenrichs 3/4/2010 19:29'!
resolvePackageSpec: packageSpec cachedGofer: gofer

	|  versionReference references |
	versionReference := packageSpec goferLoaderReference.
	(references := versionReference resolveAllWith: gofer) isEmpty 
		ifTrue: [ ^nil ].
	^references last asMetacelloCachingResolvedReference.! !

MetacelloFetchingMCSpecLoader subclass: #MetacelloNullRecordingMCSpecLoader
	instanceVariableNames: 'afterLoads beforeLoads evalDoits'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metacello-MC-Loaders'!

!MetacelloNullRecordingMCSpecLoader methodsFor: 'accessing' stamp: 'DaleHenrichs 3/11/2010 16:33'!
actionLabel

	^'Recording '! !

!MetacelloNullRecordingMCSpecLoader methodsFor: 'accessing' stamp: 'DaleHenrichs 3/10/2010 14:50'!
afterLoads

	afterLoads == nil ifTrue: [ afterLoads := OrderedCollection new ].
	^afterLoads! !

!MetacelloNullRecordingMCSpecLoader methodsFor: 'accessing' stamp: 'DaleHenrichs 3/10/2010 14:50'!
beforeLoads

	beforeLoads == nil ifTrue: [ beforeLoads := OrderedCollection new ].
	^beforeLoads! !

!MetacelloNullRecordingMCSpecLoader methodsFor: 'versionInfo' stamp: 'dkh 08/10/2009 16:39'!
currentVersionInfoFor: packageSpec

	^self loadData
		currentVersionInfoFor: packageSpec 
		ifAbsent: [ nil ]! !

!MetacelloNullRecordingMCSpecLoader methodsFor: 'actions' stamp: 'DaleHenrichs 3/10/2010 14:46'!
doingLoads: aBlock
	"escape mechanism for recording and null loaders to skip doing loaderlike things"! !

!MetacelloNullRecordingMCSpecLoader methodsFor: 'testing' stamp: 'DaleHenrichs 3/11/2010 17:18'!
ensureForDevelopment

	^false! !

!MetacelloNullRecordingMCSpecLoader methodsFor: 'accessing' stamp: 'DaleHenrichs 3/10/2010 15:43'!
evalDoits

	evalDoits == nil ifTrue: [ evalDoits := false ].
	^evalDoits! !

!MetacelloNullRecordingMCSpecLoader methodsFor: 'accessing' stamp: 'DaleHenrichs 3/10/2010 14:46'!
evalDoits: aBool

	evalDoits := aBool! !

!MetacelloNullRecordingMCSpecLoader methodsFor: 'actions' stamp: 'DaleHenrichs 4/9/2010 12:33'!
linearLoadPackageSpec: packageSpec gofer: gofer

	MetacelloPlatform current
		do:  [ | externalReference loadBlock answers fake |
			externalReference := self resolveRecordingPackageSpecReference: packageSpec gofer: gofer.
			loadBlock := [
					self preLoad: packageSpec.
					(MetacelloDirective 
						loadPackage: packageSpec 
						externalReference: externalReference 
						loader: self) addTo: self loadDirective.
					self postLoad: packageSpec ].
			(answers := packageSpec answers) notEmpty
				ifTrue: [ loadBlock valueSupplyingMetacelloAnswers: answers ]
				ifFalse: [ loadBlock value ].
			fake := packageSpec copy.
			fake name: fake file.
			self loadData 
				addVersion: fake
				versionInfo: fake
				resolvedReference: externalReference 
				packageSpec: packageSpec ]
		displaying: 'Recording ', packageSpec file! !

!MetacelloNullRecordingMCSpecLoader methodsFor: 'accessing' stamp: 'DaleHenrichs 3/11/2010 13:45'!
loadedPackages

	| packages |
	packages := OrderedCollection new.
	self loadDirective packageDirectivesDo: [:directive | packages add: directive file ].
	^packages! !

!MetacelloNullRecordingMCSpecLoader methodsFor: 'accessing' stamp: 'DaleHenrichs 4/21/2010 11:56'!
loadedRepositories

	| repos |
	repos := OrderedCollection new.
	self repositoryMap values collect: [:coll | repos addAll: coll ].
	^repos! !

!MetacelloNullRecordingMCSpecLoader methodsFor: 'accessing' stamp: 'DaleHenrichs 4/9/2010 12:23'!
loadingSpecLoader

	^self! !

!MetacelloNullRecordingMCSpecLoader methodsFor: 'actions' stamp: 'DaleHenrichs 4/9/2010 12:08'!
loadPackageDirective: aPackageLoadDirective gofer: aGofer
	"Noop"! !

!MetacelloNullRecordingMCSpecLoader methodsFor: 'actions' stamp: 'DaleHenrichs 4/9/2010 12:12'!
loadPackageDirectives: pkgLoads gofer: aGofer
	"Noop"! !

!MetacelloNullRecordingMCSpecLoader methodsFor: 'accessing' stamp: 'DaleHenrichs 3/11/2010 13:46'!
packages

	| packages |
	packages := OrderedCollection new.
	self loadDirective packageDirectivesDo: [:directive | packages add: directive spec ].
	^packages! !

!MetacelloNullRecordingMCSpecLoader methodsFor: 'doits' stamp: 'DaleHenrichs 4/8/2010 16:11'!
postLoad: packageOrVersionSpec

	self evalDoits ifFalse: [ ^self ].
	packageOrVersionSpec postLoadDoItBlock ~~ nil
		ifTrue: [ self afterLoads add: packageOrVersionSpec name, ' load' ].
	super postLoad: packageOrVersionSpec! !

!MetacelloNullRecordingMCSpecLoader methodsFor: 'doits' stamp: 'DaleHenrichs 4/8/2010 16:10'!
preLoad: packageOrVersionSpec

	self evalDoits ifFalse: [ ^self ].
	packageOrVersionSpec preLoadDoItBlock ~~ nil
		ifTrue: [ self beforeLoads add: packageOrVersionSpec name, ' load' ].
	super preLoad: packageOrVersionSpec! !

!MetacelloNullRecordingMCSpecLoader methodsFor: 'accessing' stamp: 'DaleHenrichs 3/11/2010 10:01'!
recordingSpecLoader

	^self! !

!MetacelloNullRecordingMCSpecLoader methodsFor: 'private' stamp: 'DaleHenrichs 3/11/2010 16:49'!
resolvePackageSpecReferences: packageSpec gofer: gofer

	|  versionReference references localGofer |
	localGofer := gofer.
	self hasRepositoryOverrides not
		ifTrue: [
			packageSpec repositorySpecs notEmpty
				ifTrue: [ 
					localGofer := Gofer new.
					(self repositoriesFrom: packageSpec repositorySpecs) do: [:repo | localGofer repository: repo ]]].
	(packageSpec getFile == nil or: [ self shouldDisablePackageCache ])
		ifTrue: [ 
			"don't use package-cache when trying to get latest version"
			localGofer disablePackageCache ].
	versionReference := packageSpec goferLoaderReference.
	references := versionReference resolveAllWith: localGofer.
	localGofer enablePackageCache.
	^references! !

!MetacelloNullRecordingMCSpecLoader methodsFor: 'private' stamp: 'DaleHenrichs 03/12/2010 15:01'!
resolveRecordingPackageSpecReference: packageSpec gofer: gofer

	| externalPackageReference |
	externalPackageReference := packageSpec file == nil
				ifTrue: [ GoferPackageReference name: packageSpec name ]
				ifFalse: [ GoferResolvedReference name: packageSpec file repository: nil ].
	packageSpec repositorySpecs isEmpty
		ifTrue: [  self repositoryMap at: externalPackageReference packageName put: (gofer repositories reject: [:repo | repo = MCCacheRepository default ]) ]
		ifFalse: [  self repositoryMap at: externalPackageReference packageName put: (packageSpec repositorySpecs collect: [:repoSpec | repoSpec createRepository ]) ].
	^externalPackageReference! !

MetacelloCommonMCSpecLoader subclass: #MetacelloLoadingMCSpecLoader
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metacello-MC-Loaders'!

!MetacelloLoadingMCSpecLoader methodsFor: 'accessing' stamp: 'DaleHenrichs 3/11/2010 16:33'!
actionLabel

	^'Loading '! !

!MetacelloLoadingMCSpecLoader methodsFor: 'development support' stamp: 'DaleHenrichs 3/10/2010 14:39'!
copySpec: pkgSpec from: repositorySpecs to: repository

	| gofer |
	gofer := Gofer new.
	(self repositoriesFrom: repositorySpecs) do: [:repo | gofer repository: repo ].
	^self copySpec: pkgSpec with: gofer to: repository! !

!MetacelloLoadingMCSpecLoader methodsFor: 'development support' stamp: 'DaleHenrichs 3/10/2010 14:39'!
copySpec: pkgSpec with: gofer to: repository

	| resolvedReference |
	[resolvedReference := pkgSpec goferLoaderReference resolveWith: gofer]
		on: Error
		do: [:ignored | ^nil ].
	repository storeVersion: resolvedReference version.
	^resolvedReference repository! !

!MetacelloLoadingMCSpecLoader methodsFor: 'actions' stamp: 'DaleHenrichs 3/10/2010 15:16'!
doLoad
	"NOOP"! !

!MetacelloLoadingMCSpecLoader methodsFor: 'accessing' stamp: 'DaleHenrichs 3/10/2010 14:28'!
fetchingSpecLoader

	^(MetacelloFetchingMCSpecLoader on: self spec)
		shouldDisablePackageCache: self shouldDisablePackageCache;
		loaderPolicy: self loaderPolicy copy;
		yourself! !

!MetacelloLoadingMCSpecLoader methodsFor: 'development support' stamp: 'DaleHenrichs 3/15/2010 11:36'!
goferCommitPackageUsing: repositorySpecs commitMessage: commitMessage

	| gofer repoSpecs |
	repoSpecs := self spec repositorySpecs notEmpty
				ifTrue: [ self spec repositorySpecs ]
				ifFalse: [ repositorySpecs ].
	gofer := Gofer new.
	gofer disablePackageCache.
	repositorySpecs do: [:repoSpec | gofer repository: repoSpec createRepository].
	gofer package: self spec name.
	gofer commit: commitMessage.
	^true! !

!MetacelloLoadingMCSpecLoader methodsFor: 'packages' stamp: 'DaleHenrichs 3/10/2010 14:28'!
latestPackage: aString fromRepository: repositorySpecs

	| gofer |
	gofer := Gofer new.
	gofer disablePackageCache.
	(self repositoriesFrom: repositorySpecs) do: [:repo | gofer repository: repo ].
	^([(GoferPackageReference name: aString) resolveWith: gofer]
		on: Error
		do: [:ignored | ^ nil ]) name! !

!MetacelloLoadingMCSpecLoader methodsFor: 'private' stamp: 'DaleHenrichs 4/9/2010 12:30'!
linearLoadPackageSpec: packageSpec gofer: gofer

	MetacelloPlatform current
		do:  [ | loadBlock goferLoad answers resolvedReference repo |
			resolvedReference := self resolvePackageSpec: packageSpec gofer: gofer.
			resolvedReference isNil ifTrue: [ "Package version already loaded into image" ^self ].
			loadBlock := [
				self preLoad: packageSpec.
				goferLoad := MetacelloGoferLoad on: Gofer new.
				goferLoad addResolved: resolvedReference.
				goferLoad execute.
				MetacelloPlatform current clearCurrentVersionCache.
				self postLoad: packageSpec ].
			(answers := packageSpec answers) notEmpty
				ifTrue: [ loadBlock valueSupplyingMetacelloAnswers: answers ]
				ifFalse: [ loadBlock value].
			repo := resolvedReference repository.
			self hasRepositoryOverrides
				ifTrue: [
					repo := self loaderPolicy repositoryMap 
								at: resolvedReference name 
								ifAbsent: [ resolvedReference repository ].
					resolvedReference workingCopy repositoryGroup addRepository:  repo ]
				ifFalse: [ resolvedReference workingCopy repositoryGroup addRepository: resolvedReference repository ].
			Transcript cr; show: 'Loaded -> ', resolvedReference name, ' --- ', repo description, ' --- ', resolvedReference repository description  ]
		displaying: 'Loading ', packageSpec file! !

!MetacelloLoadingMCSpecLoader methodsFor: 'development support' stamp: 'DaleHenrichs 3/6/2010 09:04'!
packagesNeedSavingUsing: repositorySpecs into: aCollection

	| wc repoSpecs repo |
	(wc := self spec workingCopy) == nil ifTrue: [ ^self ].
	(wc ancestry ancestors notEmpty and: [ wc modified not])
		ifTrue: [ ^self ].
	repoSpecs := self spec repositorySpecs notEmpty
				ifTrue: [ self spec repositorySpecs ]
				ifFalse: [ repositorySpecs ].
	repo := (self spec getFile == nil or: [ wc ancestry ancestors isEmpty ])
		ifTrue: [ (self repositoriesFrom: repoSpecs ignoreOverrides: true) first ]
		ifFalse: [
			([ self resolveSpec: self spec from: repoSpecs ] 
				on: Error 
				do: [:ignored | ^self ]) repository ].
	aCollection add: self spec -> repo! !

!MetacelloLoadingMCSpecLoader methodsFor: 'doits' stamp: 'DaleHenrichs 3/10/2010 14:31'!
postLoad: packageOrVersionSpec

	| block |
	(block := packageOrVersionSpec postLoadDoItBlock) ~~ nil
		ifTrue: [ block valueWithPossibleArgs: { self. packageOrVersionSpec. } ]! !

!MetacelloLoadingMCSpecLoader methodsFor: 'doits' stamp: 'DaleHenrichs 3/10/2010 14:31'!
preLoad: packageOrVersionSpec

	| block |
	(block := packageOrVersionSpec preLoadDoItBlock) ~~ nil
		ifTrue: [ block valueWithPossibleArgs: { self. packageOrVersionSpec. } ]! !

!MetacelloLoadingMCSpecLoader methodsFor: 'development support' stamp: 'DaleHenrichs 3/10/2010 14:42'!
repositoryFor: pkgSpec from: repositorySpecs

	^([self resolveSpec: pkgSpec from: repositorySpecs]
		on: Error
		do: [:ignored | ^nil ]) repository! !

!MetacelloLoadingMCSpecLoader methodsFor: 'development support' stamp: 'DaleHenrichs 3/10/2010 14:42'!
repositoryFor: pkgSpec with: gofer

	^([self resolveSpec: pkgSpec with: gofer]
		on: Error
		do: [:ignored | ^nil ]) repository! !

!MetacelloLoadingMCSpecLoader methodsFor: 'development support' stamp: 'DaleHenrichs 3/10/2010 14:43'!
resolveSpec: pkgSpec from: repositorySpecs

	| gofer |
	gofer := Gofer new.
	gofer disablePackageCache.
	(self repositoriesFrom: repositorySpecs ignoreOverrides: true) 
		do: [:repo | gofer repository: repo ].
	^self resolveSpec: pkgSpec with: gofer! !

!MetacelloLoadingMCSpecLoader methodsFor: 'development support' stamp: 'DaleHenrichs 3/10/2010 14:44'!
resolveSpec: pkgSpec with: gofer

	^pkgSpec goferLoaderReference resolveWith: gofer! !

!MetacelloLoadingMCSpecLoader methodsFor: 'development support' stamp: 'DaleHenrichs 3/6/2010 09:04'!
savePackageUsing: repositorySpecs

	| wc repo repoSpecs newVersion |
	(wc := self spec workingCopy) == nil ifTrue: [ ^false ].
	(wc ancestry ancestors notEmpty and: [ wc modified not])
		ifTrue: [ ^false ].
	repoSpecs := self spec repositorySpecs notEmpty
				ifTrue: [ self spec repositorySpecs ]
				ifFalse: [ repositorySpecs ].
	(self spec getFile == nil or: [ wc ancestry ancestors isEmpty ])
		ifTrue: [ repo := (self repositoriesFrom: repoSpecs ignoreOverrides: true) first ]
		ifFalse: [
			[ 	| newer |
				repo := (self resolveSpec: self spec from: repoSpecs) repository.
				newer := wc possiblyNewerVersionsIn: repo.
				newer isEmpty not 
					ifTrue: [
						(MetacelloPlatform current confirm: 'CAUTION!! These versions in the repository may be newer:', 
							String cr, newer printString, String cr,
							'Do you really want to save this version?') ifFalse: [ ^false ]] ] 
				on: Error 
				do: [:ignored | ^false ] ].
	(newVersion :=  wc newVersion) == nil ifTrue: [ ^false ].
	repo storeVersion: newVersion.
	^true! !

!MCHttpRepository methodsFor: '*metacello-mc' stamp: 'DaleHenrichs 3/5/2010 14:45'!
asRepositorySpecFor: aMetacelloMCProject

	^(aMetacelloMCProject repositorySpec)
		description:  self description;
	 	type: 'http';
		yourself! !
